skipQueueApp.controller('CategoryShowCtrl', function ($rootScope, $scope, OrderCart, 
    $ionicScrollDelegate, RestaurantService, category, $timeout, $stateParams, $ionicSideMenuDelegate) {    
    $scope.category = {};
    $scope.subCategories = [];
    $scope.orgScrollHeight = 0;
    $scope.currentScrollHghtSubCat = 0;
    $scope.init = function () {
        
        // Parse data
        var parseResult = $scope.parseData(RestaurantService.parseDataCategoryPage, category);
        
        // Check parse data result if error return
        if(!$scope.isParseDataSuccess(parseResult)){
            return;
        }
        $scope.category = parseResult.obj.category;
        $scope.subCategories = parseResult.obj.subCategories;
        
        $scope.orderCart = OrderCart.getCart();
        
        if($scope.orderCart.currentSubCat){
            $scope.shownSubCategory = $scope.orderCart.currentSubCat;
            // if we added the dish from this sub-cat and sub-sub-cat then we will open this sub-cat and sub-sub-cat
            if($scope.orderCart.currentSubSubCat){
                $scope.shownSubSubCategory = $scope.orderCart.currentSubSubCat;
            }
        }else{
            // if this is the first time we go to this category then keep old logic
            if($scope.subCategories.length == 1){
                $scope.shownSubCategory = $scope.subCategories[0];
                OrderCart.setSubCat($scope.subCategories[0]); // HocOT - ticket 1171
            }
        }
        
        $scope.catDishes = parseResult.obj.dishes;
        
        if($stateParams.openOrderCart && $stateParams.openOrderCart === "true"){
            $ionicSideMenuDelegate.toggleRight(true);
        }
    };
        
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });
    
    $scope.showHideSubCategory = function (subCategory) {
        if($scope.orgScrollHeight == 0 && $scope.subCategories.length > 1){
            $scope.orgScrollHeight = $('.scroll').height();
        }
        $scope.currentScrollHghtSubCat = $scope.orgScrollHeight;
        if (subCategory.subSubCategories.length > 0 || subCategory.dishes.length > 0) {
            if ($scope.isSubCategoryShown(subCategory)) {
                $scope.shownSubCategory = null;
                OrderCart.setSubCat(null);
            } else {
                $scope.shownSubCategory = subCategory;
                OrderCart.setSubCat(subCategory);
                $scope.currentScrollHghtSubCat += subCategory.subSubCategories.length * 51; // height of sub cat title
                if(subCategory.isShowDishImage){
//                    console.log('width = ' + $(window).width());
                    var height = $(window).width()/2 + 65;
                    $scope.currentScrollHghtSubCat += Math.ceil(subCategory.dishes.length / 2) * height; // height of image 150 + text 65
                }else{
                    $scope.currentScrollHghtSubCat += subCategory.dishes.length * 70; // height of line
                }
            }
            var cateIndex = $.inArray(subCategory, $scope.subCategories);
            if(cateIndex > -1){
                $ionicScrollDelegate.scrollTo(0, (cateIndex * 51));
            }
        }
       $('.scroll').height($scope.currentScrollHghtSubCat);
       $ionicScrollDelegate.resize();        
    };

    $scope.toggleSubCategory = function (subCategory) {    
        if(($('#cat-img').css('display') != "none") 
                && ($scope.shownSubCategory == null)){
            $('#cat-img').slideUp(500);
            $scope.showHideSubCategory(subCategory);
        }else if ($('#cat-img').css('display') == "none"){
            $scope.showHideSubCategory(subCategory);
            if($scope.shownSubCategory == null){
                $timeout(function(){
                    $('#cat-img').slideDown(500);
                }, 400);
            }
        }else {
            $scope.showHideSubCategory(subCategory);
        }
    };
    
    $scope.isSubCategoryShown = function (subCategory) {
        //return $scope.shownSubCategory === subCategory;
        // HocOT - ticket 1171 - because the === operator compare if the object refer to the same object 
        // the only solution to check is to compare the id
        if($scope.shownSubCategory){
            return $scope.shownSubCategory.id === subCategory.id;
        }
        return false;
    };

    $scope.toggleSubSubCategory = function (subSubcategory) {
        var height = $scope.currentScrollHghtSubCat;
        if (subSubcategory.dishes.length > 0) {
            if ($scope.isSubSubCategoryShown(subSubcategory)) {
                $scope.shownSubSubCategory = null;
                OrderCart.setSubSubCat(null);
            } else {
                $scope.shownSubSubCategory = subSubcategory;
                OrderCart.setSubSubCat(subSubcategory);
                if(subSubcategory.isShowDishImage){
                    var height = $(window).width()/2 + 65;
                    height += Math.ceil(subSubcategory.dishes.length / 2) * height;
                }else{
                    height += subSubcategory.dishes.length * 70;
                }
            }
        }
        $('.scroll').height(height);
        $ionicScrollDelegate.resize();
       //setTimeout($ionicScrollDelegate.resize(), 2000);
    };
    
    $scope.isSubSubCategoryShown = function (subSubcategory) {
        //return $scope.shownSubSubCategory === subSubcategory;
        // HocOT - ticket 1171 - because the === operator compare if the object refer to the same object 
        // the only solution to check is to compare the id
        if($scope.shownSubSubCategory !== undefined){
            return $scope.shownSubSubCategory.id === subSubcategory.id;
        }
        return false;
    };
    
    $scope.$on('changeItemInCart', function(event, data){
        if(data){
            angular.forEach($scope.subCategories, function(subCat){
                //Update quantity in cart of sub cat dishes
                angular.forEach(subCat.dishes, function(dish){
                    dish.quantityInCart = RestaurantService.getDishQuantityInCart(dish.id);
                });
                
                //Update quantity in cart of sub sub cat dishes
                angular.forEach(subCat.subSubCategories, function(subSubCat){
                    angular.forEach(subSubCat.dishes, function(dish){
                        dish.quantityInCart = RestaurantService.getDishQuantityInCart(dish.id);
                    });
                });
            });
        }
    });
    
//    $scope.like = function(dishId, $event){
//        // TODO like dish
//        // Call api  
//        $scope.stopPropagation($event);
//        console.log('like dish');
//    };
        
    $scope.init();
});