skipQueueApp.controller('ConfirmDetailCtrl', function ($rootScope, $scope, OrderService, OrderCart, GlobalRestaurant, data, Utilities, $ionicSideMenuDelegate, Validation) {
    $ionicSideMenuDelegate.toggleRight(false);

    $scope.init = function () {
        // Parse model data to view model
        $scope.isEditDate = false;
        
        var parseResult = $scope.parseData(OrderService.parseConfirmDetail, data);
        $scope.orderCart = OrderCart.getCart();

        //$scope.dishes = $scope.orderCart.dishes;
        $scope.currency = $scope.orderCart.currency;
        
        $scope.orderCart.orderTypeName = getOrderTypeName($scope.orderCart.selectedOrderType);

        if (!$scope.isParseDataSuccess(parseResult)) {
            return;
        }

        // success case
        $scope.bill = parseResult.obj;
        $scope.dishes = parseResult.obj.dishes;
        
        if ($scope.orderCart.selectedOrderType == 3 || $scope.orderCart.selectedOrderType == 5) {
            $scope.orderCart.date = Utilities.getDateFromDatetime($scope.orderCart.dateTime);
            $scope.orderCart.time = Utilities.getTimeFromDateTime($scope.orderCart.dateTime);
        }
    };
    
    $scope.makePayment = function (isValid) {
        if (!isValid) {
            return;
        }

        if ($scope.orderCart.selectedOrderType == 3 || $scope.orderCart.selectedOrderType == 5) {
            var temp = Utilities.formatDateTime(constant.formatDateTime, new Date($scope.orderCart.date.toDateString() + ' ' + $scope.orderCart.time.toTimeString()));
            var orderDateTime = new Date($scope.orderCart.date.toDateString() + ' ' + $scope.orderCart.time.toTimeString());
//            if (!Validation.isAfterNow(temp)) {
            if (!Validation.isAfterNow_new(orderDateTime)) { // caoth :(
                Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.time_before_now);
                return;
            }
            OrderCart.setDateTime(temp);
        }
        OrderCart.setGrandTotal($scope.bill.grandTotal);

        $rootScope.$broadcast('loading:show');
        OrderService.confirmOrder().then(function (res) {
            $rootScope.$broadcast('loading:hide');
            OrderCart.setGrandTotal(res.grand_total);
            OrderCart.setOrderId(res.order_id);
            OrderCart.setOrderNumber(res.order_no);
            // HocOT - ticket 1191
            // because I don't want to change too much code, I will check the is_skipque flag here
            if(!constant.is_skipque){
                $scope.goToPage(page_name.payment_success);
            }else{
                $scope.goToPage(page_name.make_payment);
            }
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, error.message);
        });
    };

    $scope.changeOrderType = function () {
        Utilities.showConfirm('Warning', constant.language.msg_change_order_type, function (result) {
            if (result) {
                clearOrderCartGlobalResAndGoBackOrderType();
            }
        });
    };

    $scope.changeRestaurant = function () {
        Utilities.showConfirm('Warning', constant.language.msg_change_oulet, function (result) {
            if (result) {
//                clearOrderCartGlobalResAndGoBackOrderType();
                clearOrderCartGlobalResAndGoToMainPage();
            }
        });
    };
    
    $scope.changeAddress = function(){
        Utilities.showConfirm('Warning', constant.language.msg_change_address, function (result) {
            if (result) {
                clearOrderCartGlobalResAndGoBackOrderType();
            }
        });
    };

    var clearOrderCartGlobalResAndGoBackOrderType = function () {
        OrderCart.clearExceptOrderIdAndOrderNumber();
        GlobalRestaurant.clear();
        $scope.goToPage(page_name.order_type);
    };
    
    var clearOrderCartGlobalResAndGoToMainPage = function () {
        OrderCart.clearExceptOrderIdAndOrderNumber();
        GlobalRestaurant.clear();
        $scope.goToPage(page_name.index);
    };

    $scope.changeDate = function () {
        $scope.isEditDate = true;
        alert('edit date');
        $('#date').trigger('tab');
    };

    $scope.turnOffEdit = function () {

        alert('blur');
        $scope.isEditing = false;
    };

    $scope.turnOffEditDate = function () {
        alert('new Date: ');
        alert($scope.orderCart.date);
        alert('blur');
        $scope.isEditDate = false;
    };
    
    var getOrderTypeName = function(orderTypeId){
        switch(orderTypeId){
            case constant.order_type_child_pickup_now:
            {
                return constant.order_type_child_pickup_now_name;
                break;
            }
            case constant.order_type_child_pickup_later:
            {
                return constant.order_type_child_pickup_later_name;
                break;
            }
            case constant.order_type_child_delivery_now:
            {
                return constant.order_type_child_delivery_now_name;
                break;
            }
            case constant.order_type_child_delivery_later:
            {
                return constant.order_type_child_delivery_later_name;
                break;
            }
            default:
                return 'order type';
                break;
        }
    };

    $scope.$on("$ionicView.beforeLeave", function () {
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function () {
        $rootScope.$broadcast('loading:hide');
    });
    
    $scope.init();
});