skipQueueApp.controller ('ContactCtrl', function($rootScope, $scope, Validation, UserService, Utilities, GlobalUser) {
    $scope.user = {email: '', message:''};
    $scope.userId = '';
    
    $scope.init = function(){
        GlobalUser.getUser().then(function(user){
           if(user){
                $scope.user.email = user.email;//"Brandon";//                                           
            } 
        });
    };
    
    $scope.sendContactUS = function(){
        if(!validateSendContactUS()){
            return;
        }
        //call api
        UserService.sendContactUs(constant.chain_id, $scope.user.email, $scope.user.message).then(function(resultData){
           $rootScope.$broadcast('loading:hide');
           Utilities.showAlert(constant.language.msg_title_success, constant.language.msg_contact_us_success);
           $scope.goToPage(page_name.about);
        }, function(error){
                $rootScope.$broadcast('loading:hide');
                $scope.errorHandler(error);
        });
    };
    
    function validateSendContactUS(){
        var arrError = [];
        var val_email = Validation.validationEmail($scope.user.email);
        if(!val_email.result){
            arrError.push(val_email.message);
        }
        if(!$scope.user.message){
            arrError.push(constant.language.msg_contact_us_content);
        }
        if(arrError.length>0){
            var errObj={errorCode: error_code.validation, message: arrError.join(' <br /> ')};
            $scope.errorHandler(errObj);
            return false;
        }
        return true;
    }
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });
});