skipQueueApp.controller('DeliveryCtrl', function ($scope, $rootScope, $ionicPopup, GlobalUser, GlobalRestaurant, ConnectionService, Utilities,
        OrderCart, Validation, userData, OrderTypeService) {
    $scope.address_edit = {};
    $scope.indexAddressEdit = -1;
    $scope.isModeEdit_address = true;// true: mode edit address, false: mode add new address.
    $scope.is_address = false;//true: mode open Delivery Order, false: mode open Address detail.

    $scope.init = function () {
        if (userData) {
            $scope.del_order = {
                user_id: userData.user_id,
                phone: userData.phone,
                delivery_date: new Date(),
                delivery_time: null,
                address_selected: null,
                arr_address: [].concat(angular.copy(userData.address))
            };
            if($scope.del_order.arr_address.length == 1){
                $scope.del_order.arr_address[0].isSelected = true;
                $scope.del_order.address_selected = angular.copy($scope.del_order.arr_address[0]);
            }
        }
    };

    $scope.getNameById = function (fieldName, id) {
        var arr = $scope[fieldName];
        var temp = $.grep(arr, function (x) {
            return x.id === id;
        });
        return temp.length > 0 ? temp[0].name : '';
    };

    $scope.addressSelected = function (id) {
        resetArrAddress();
        $scope.del_order.arr_address[id].isSelected = true;
        $scope.del_order.address_selected = angular.copy($scope.del_order.arr_address[id]);
    };

    var resetArrAddress = function () {
        for (var i = 0; i < $scope.del_order.arr_address.length; i++) {
            $scope.del_order.arr_address[i].isSelected = false;
        }
    };

    $scope.goToEditPage = function (arr_index, $event) {
        $scope.stopPropagation($event);
        $scope.goToPageWithParams(page_name.add_address, {index: arr_index, pageName: 'delivery'});
    };

    $scope.backDeliveryOrder = function () {
        $scope.goToPage(page_name.delivery_order);
        $scope.is_address = false;
    };

    $scope.btnContinuteNowClicked = function (isValid) {
        if (!validateData(isValid)) {
            return;
        }

        if (!isValid) {
            return;
        }

        OrderTypeService.checkSupportedOrderType(constant.order_type_child_delivery_now, null, null, function () {
            addSameDataToOrderCart();
            OrderCart.setSelectedOrderType(constant.order_type_child_delivery_now);
            
            // caoth recommendation page
            var dish = OrderCart.getCart().tempItem;
            if(dish !== null) {                    
                if (dish.selectedSku.hasRecommendation && !dish.isRecommendation) {
                    $scope.goToPageWithParams(page_name.dish_recommendations, {dishId: dish.id, parentId: dish.guid});                        
                    OrderCart.clearTempItem();
                    return;
                }
            }
            
            var page = choosePageToGo();
            $scope.goToPage(page);
        });
    };

    $scope.btnContinuteAdvClicked = function (isValid) {
        if (!validateData()) {
            return;
        }
        if (!validDateTime()) {
            return;
        }
        if (!isValid) {
            return;
        }
        OrderTypeService.checkSupportedOrderType(constant.order_type_child_delivery_later, $scope.del_order.delivery_date.toDateString(), $scope.del_order.delivery_time.toTimeString(), function () {
            addSameDataToOrderCart();
            OrderCart.setSelectedOrderType(constant.order_type_child_delivery_later);
            OrderCart.setDateTime(Utilities.formatDateTime(constant.formatDateTime, new Date($scope.del_order.delivery_date.toDateString() + ' ' + $scope.del_order.delivery_time.toTimeString())));
            
            // caoth recommendation page
            var dish = OrderCart.getCart().tempItem;
            if(dish !== null) {                    
                if (dish.selectedSku.hasRecommendation && !dish.isRecommendation) {
                    $scope.goToPageWithParams(page_name.dish_recommendations, {dishId: dish.id, parentId: dish.guid});                        
                    OrderCart.clearTempItem();
                    return;
                }
            }
            
            var page = choosePageToGo();
            $scope.goToPage(page);
        });
    };

    var choosePageToGo = function () {
        var globalRes = GlobalRestaurant.getAll();
        var resId = globalRes.resId;
        //if restaurant Id not exist, go to find res. of pickup 
        if (!Utilities.emptyOrNull(resId)) {
            return page_name.res_delivery;
        }

        //if restaurant Id exists 

        // goto res. menu        
        return page_name.res_menu;
    };

    var addSameDataToOrderCart = function () {
        OrderCart.setAddress($scope.del_order.address_selected);
        OrderCart.setPhone($scope.del_order.phone);
    };

    var validateData = function () {
        if ($scope.del_order.phone === '' || !$scope.del_order.phone) {
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.phone_required);
            return false;
        }
        
        var valid = Validation.validationPhone($scope.del_order.phone);
        if(!valid.result){
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, valid.message);
            return false;
        }

        if (!$scope.del_order.address_selected) {
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.miss_address);
            return false;
        }

        return true;
    };

    var validDateTime = function () {
        if ($scope.del_order.delivery_time === '' || !$scope.del_order.delivery_time) {
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.del_time_required);
            return false;
        }
        //var datetime = new Date($scope.del_order.delivery_date.toDateString() + ' ' + $scope.del_order.delivery_time.toTimeString());
        var datetime = moment($scope.del_order.delivery_date.toDateString() + ' ' + $scope.del_order.delivery_time.toTimeString()).format(constant.parse_time_format);
        if (!Validation.isAfterNow(datetime)) {
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.time_before_now);
            return false;
        }

        return true;
    };

    $scope.$on("$ionicView.beforeLeave", function () {
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function () {
        $rootScope.$broadcast('loading:hide');
    });

    $scope.init();
});