skipQueueApp.controller('DishDetailsCtrl', function ($rootScope, $scope, $state, $rootScope, $ionicScrollDelegate,
        OrderService, OrderCart, RestaurantService, dish, Utilities, GlobalRestaurant, $ionicSideMenuDelegate) {

    $scope.dish = {};
    $scope.init = function () {
        
        $scope.res = GlobalRestaurant.getAll();        
        $scope.selectedSku = null;
        $scope.isShowingSku = false;
        
        // Parse model data to view model
        var parseResult = $scope.parseData(RestaurantService.parseDataDishInfo, dish);
        // Check parse data result
        // if error
        // return
        if (!$scope.isParseDataSuccess(parseResult)) {
            return;
        }

        // HocOT - ticket 1171
        $scope.orderCart = OrderCart.getCart();

        // success case
        $scope.dish = parseResult.obj;
        var skuMin = RestaurantService.getSkuHasMinPriceDishDetail($scope.dish);
        if ($scope.dish.customizations && $scope.dish.customizations.length > 0) {
            $scope.selectSkuNotChangeCus(skuMin);
        } else {
            $scope.selectSku(skuMin, false);
        }
        
        getTotalPrice(true);
    };

    $scope.$on("$ionicView.beforeLeave", function () {
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function () {
        $rootScope.$broadcast('loading:hide');
    });

    // Set width for option container in view which contains options
//    $scope.initImgCusOptContainer = function (cus) {
//        var width = cus.options.length * 125;
//        return {'width': width.toString() + 'px'};
//    };

    // Confirm add dish to order
    $scope.showAddOrderConfirm = function () {
        goNextPage();
    };

    // Toogle show/hide customization group
    $scope.toggleCategory = function (category, id) {
        if (id === 'skus') {
            $scope.isShowingSku = !$scope.isShowingSku;
            setTimeout($ionicScrollDelegate.resize(), 400);
        } else if (category.options.length > 0) {
            category.isShowing = !category.isShowing;
            $('#' + id).slideToggle(0, function () {
                // Animation complete.
                $ionicScrollDelegate.resize();
            });
        }
    };

    // Check selected sku - for render view
    $scope.isSelectedSku = function (sku) {
        return $scope.dish.selectedSku === sku;
    };

    // Check selected option - for render view
    $scope.isSelectedOpt = function (opt) {
        if(!opt.isActive){
            opt.quantity = 0;
            return false;
        }
        return opt.quantity > 0;
    };

    // Set selected sku first
    $scope.selectSkuNotChangeCus = function (sku) {
        $scope.dish.selectedSku = sku;
        getTotalPrice(true);
    };

    // Change selected sku
    $scope.selectSku = function (sku, check_validation) {
        $scope.dish.selectedSku = sku;

        $scope.dish.customizations = changeCustomizationsBySku(sku);

        // Caculate total price
        getTotalPrice(check_validation);
    };

    $scope.isShowingCategory = function (category) {
        return category.isShowing ? category.isShowing : false;
    };

    $scope.increseNumberOfDish = function () {
        $scope.dish.quantity++;

        // Caculate total price
        getTotalPrice(true);
    };

    $scope.decreaseNumberOfDish = function () {
        if ($scope.dish.quantity > 1) {
            $scope.dish.quantity--;

            // Caculate total price
            getTotalPrice(true);
        }
    };
    $scope.toggleSelectOption = function (opt) {
        if(!opt.isActive || opt.isStockOut){
            return false;
        }
        
        if (!opt.hasCounter && !opt.isPreselectedLocked) {
            
            //var qyt = opt.quantity ? 0 : 1;
            opt.quantity = (opt.quantity + 1)%2;
            // caculate total price
            getTotalPrice(true);
        }
    };

    $scope.increaseCustomizationQuantity = function (opt, cus) {
        if(!opt.isActive){
            return false;
        }
        opt.quantity++;
        // caculate total price
        getTotalPrice(false); // not show alert but show max quantity warning, #1173
        validationCustomizations(RestaurantService.getCustomizationName($scope.dish), false, true);
    };

    $scope.decreaseCustomizationQuantity = function (opt, cus) {
        if(!opt.isActive){
            return false;
        }
        if (opt.quantity > 0) {
            opt.quantity--;

            // caculate total price
            getTotalPrice(true);
        }
    };

    // PRIVATE FUNCTION
    function getTotalPrice(check_validation) {
        if(!$scope.dish.selectedSku) return;
        $scope.dish.basePrice = RestaurantService.getDishBasePrice($scope.dish);
        $scope.dish.totalPrice = RestaurantService.getDishTotalPrice($scope.dish);
        $scope.dish.customizations = RestaurantService.getCustomizationName($scope.dish);
        
        // caoth 1173
        if(check_validation){
            validationCustomizations($scope.dish.customizations);
        }
    }

//    function notValidCustomizations(groups) {
//        var isStop = false;
//
//        angular.forEach(groups, function (cus) {
//            if (!isStop && (cus.minOpt > 0 || cus.maxOpt > 0)) {
//                var optsQuantity = 0;
//                angular.forEach(cus.options, function (opt) {
//                    optsQuantity += opt.quantity;
//                });
//
//                cus.chooseOptQuantity = optsQuantity;
//
//                if ((cus.chooseOptQuantity < cus.minOpt && cus.minOpt > 0)
//                        || (cus.chooseOptQuantity > cus.maxOpt && cus.maxOpt > 0)) {
//                    //cus.minOpt > 0 && cus.maxOpt > 0
//                    var msg = ': quantity must be ' + cus.minOpt + ' to ' + cus.maxOpt;
//                    if (cus.minOpt > 0 && cus.maxOpt === 0) {
//                        msg = ': quantity must be greater than or equal to ' + cus.minOpt;
//                    } else if (cus.minOpt === 0 && cus.maxOpt > 0) {
//                        msg = ': quantity must be less than or equal to ' + cus.maxOpt;
//                    }
//
//                    isStop = true;
//                    Utilities.showAlertError(constant.language.err_msg.mess_title_error, cus.name + msg);
//                }
//            }
//        });
//        return isStop;
//    }

    function notValidRecommendationQty(recommend) {
        if (!recommend.isRecommendation)
            return false;

        var dish = OrderCart.getDish($state.params.parentId);
        if (!dish) {
            recommend.isRecommendation = false;
            return false;
        }

        if (dish.quantity < recommend.quantity) {
            var msg = 'Recommendation quantity must be less than or equal ' + dish.quantity;
            Utilities.showAlert(constant.language.err_msg.mess_title_error, msg);
            return true;
        }
        return false;
    }
    
    function validationCustomizations(groups, showAlert, showMaxOption){
        showAlert = typeof showAlert !== 'undefined' ? showAlert : false;
        showMaxOption = typeof showMaxOption !== 'undefined' ? showMaxOption : false;
        
        // ValidCustomizations
        var isStop = false;
        angular.forEach(groups, function (cus) {
            if (cus.minOpt > 0 || cus.maxOpt > 0) {
                var optsQuantity = 0;
                angular.forEach(cus.options, function (opt) {
                    optsQuantity += opt.quantity;
                });

                cus.chooseOptQuantity = optsQuantity;
                if ((cus.chooseOptQuantity < cus.minOpt && cus.minOpt > 0)
                        || (cus.chooseOptQuantity > cus.maxOpt && cus.maxOpt > 0)) {
                    isStop = cus.isHighlight = true;
                    console.log(cus.isHighlight);
                }
                else{
                    cus.isHighlight = false;
                }
                
                if(showMaxOption && (cus.chooseOptQuantity > cus.maxOpt && cus.maxOpt > 0)) {
                    var msg = constant.language.msg_option_max + cus.maxOpt + constant.language.msg_options;
                    Utilities.jsShortToast(msg);
                }
            }
        });
        
        if(isStop){
            if(showAlert) {
                Utilities.jsShortToast(constant.language.mess_content_check_info_highlight_in_red);
            }
            
//            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.mess_content_check_info_highlight_in_red);
            return false;
        }
        
        return true;
    }

    var goNextPage = function () {
        // Check min - max of customization group
        var groups = $scope.dish.customizations;
        if(!validationCustomizations(groups, true))
            return;
//        if (validationCustomizations(groups)) {
//            return;
//        }
//
        if (notValidRecommendationQty($scope.dish)) {
            return;
        }
        
        // ToDo caoth: check OrderCart selectedOrderType
        // if not set --> save (temporarily) the selected-dish and go to Order Type page

        // else (already select order type), continue as current code
        // (may save the selected-dish in the OrderCart ...)

        var guid;
        if ($state.params.guid) {
            guid = $state.params.guid;
            // update item in cart
            OrderService.updateItemInCart($scope.dish, guid);
        } else {
            // addDishToOrderCart
            guid = OrderService.addToCart($scope.dish);
        }

        // Check user has login in
        $scope.checkLogin().then(function (data) {
            if (data) {                
                if (OrderService.getCurrentOrderType() === constant.all_order_type) {
                    OrderService.clearOrderCartAndSetTempItem(guid);
                    $scope.goToPageWithParams(page_name.order_type);
                    return;
                }
                
                if ($scope.dish.selectedSku.hasRecommendation && !$scope.dish.isRecommendation) {
                    $scope.goToPageWithParams(page_name.dish_recommendations, {dishId: $scope.dish.id, parentId: guid});
                    return;
                }

                //$scope.goToPage(page_name.res_menu);
                // HocOT - ticket 1171 - make the app go to the last page before add item to order cart
//                if($scope.orderCart.currentSubCat){
//                    //$scope.goToPage(page_name.category_show);
//                    var open_order_cart = false;
//                    if ($state.params.guid){
//                        open_order_cart = true;
//                    }
//                    $scope.goToPageWithParams(page_name.category_show, {'openOrderCart': open_order_cart});
//                }else{
//                    // probaly edit case, then go to res_menu page
//                    //$scope.goToPage(page_name.res_menu);
//                    $scope.goToPageWithParams($scope.previousPage1, {'openOrderCart': true});
//                }
                
                var open_order_cart = $state.params.guid ? true : false;
//                $scope.goToPageWithParams($scope.previousPage1, {'openOrderCart': open_order_cart});
                $scope.goPreviousHistory();                
            }
            else {
                Utilities.showConfirm(constant.language.msg_login_required, constant.language.msg_login_to_continute, function (result) {
                    if (result) {
                        var currentName = page_name.res_menu;
                        var params = {};
                        if (OrderService.getCurrentOrderType() === constant.all_order_type) {
                            currentName = page_name.order_type;
                        }

                        if ($scope.dish.selectedSku.hasRecommendation && !$scope.dish.isRecommendation) {
                            currentName = page_name.dish_recommendations;
                            params = {
                                dishId: $scope.dish.id,
                                parentId: guid
                            };
                        }

                        Utilities.goBackToLogin(currentName, params);
                    } else {
                        OrderCart.removeFromCart(guid);
                    }
                });
            }
        });
    };

    var changeCustomizationsBySku = function (sku) {
        return angular.copy(sku.customizations);
    };
    
    $scope.$on("$ionicView.beforeLeave", function () {
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function () {
        $rootScope.$broadcast('loading:hide');
    });

    $scope.init();
});