skipQueueApp.controller('FindRestaurantsCtrl', function ($rootScope, $scope, GlobalRestaurant, OrderCart, RestaurantService, $ionicPlatform, $ionicScrollDelegate, restaurants, Paging) {
    //$scope.info = "Crust Pizza";
    $scope.restaurant_default = "img/i-crust.png";
    
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });

    $scope.init = function () {
        var restaurantList;
        var mode = 'callAPI';
        if (mode === 'callAPI') {
            // Parse model data to view model
            var parseResult = $scope.parseData(RestaurantService.parseDataFindRestaurants, restaurants);
            
            if(!$scope.isParseDataSuccess(parseResult)){
                return;
            }
            restaurantList = parseResult.obj;
        } else {
            restaurantList = initTest();
        }

        $scope.originRestaurants = angular.copy(restaurantList);

        $scope.Paging = new Paging(restaurantList);
        $scope.restaurants = $scope.Paging.loadMore();
    };

    var searchRestaurantByNameOrCuisine = function (arr, search) {
        //return $filter('filter')(arr, {name: search} || {cuisineType: search});
        return arr.filter(function (restaurant) {
            return restaurant.name.toLowerCase().indexOf(search.toLowerCase()) >= 0
                    || restaurant.cuisineType.toLowerCase().indexOf(search.toLowerCase()) >= 0;
        });
    };

    $scope.keyPress = function (e) {
        if (e.which === 13 || e.which === 32) {
            //e.preventDefault();
            if ($scope.search || $scope.search === '') {
                if ($scope.search === '') {
                    $scope.clearSearch();
                } else {
                    var result = searchRestaurantByNameOrCuisine(angular.copy($scope.originRestaurants), $scope.search);
                    $scope.Paging.init(result);
                    $scope.restaurants = $scope.Paging.loadMore();
                }
                $ionicScrollDelegate.scrollTop();
            }
            cordova.plugins.Keyboard.close();
        }
    };

    $scope.clearSearch = function () {
        $scope.search = '';
        var result = angular.copy($scope.originRestaurants);
        $scope.Paging.init(result);
        $scope.restaurants = $scope.Paging.loadMore();
    };

    $scope.isCanLoadMore = function () {
        return $scope.Paging.isCanLoadMore();
    };

    $scope.loadMore = function () {
        //$scope.isLoading = true;
        var moreItems = $scope.Paging.loadMore();
        if (moreItems.length !== 0) {
            $scope.restaurants = $scope.restaurants.concat(moreItems);
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };

    $scope.goToRestaurantShow = function(res, $event, index){
        // Stop propanation
        $scope.stopPropagation($event);
        // Update resId in globalRestaurant with the choosen resId
        var globalRes = GlobalRestaurant.getAll();
        globalRes.resId = res.id;
        globalRes.resName = res.name;
        globalRes.skuHeaderText = res.skuHeaderText;
        globalRes.orderTypes = $scope.restaurants[index].arr_order_types;
        OrderCart.setSelectedOrderType(constant.all_order_type);
        GlobalRestaurant.setResData(globalRes);
        // Go to restaurant menu
        $scope.goToPage(page_name.res_show);
    };
    
    $scope.goToRestaurantMenuPage = function(res, index){
        // Update resId in globalRestaurant with the choosen resId
        var globalRes = GlobalRestaurant.getAll();
        globalRes.resId = res.id;
        globalRes.resName = res.name;
        globalRes.skuHeaderText = res.skuHeaderText;
        globalRes.orderTypes = $scope.restaurants[index].arr_order_types;
        OrderCart.setSelectedOrderType(constant.all_order_type);
        GlobalRestaurant.setResData(globalRes);
        // Go to restaurant menu
        $scope.goToPage(page_name.res_menu);
    };
    
    $scope.back = function() {
        // handle back function here
        
        //ideally there should be a param called previous page, which is passed from previous screen
        $scope.goBack(page_name.index);
    };
    
    $ionicPlatform.onHardwareBackButton(function() {
        $scope.back();
    });
    
    $scope.init();
    
});