/* global skipQueueApp, constant */
// define common methods for all controller

// config spinning to only appear for api call
skipQueueApp.config(function ($httpProvider) {
    $httpProvider.interceptors.push(function ($rootScope, $q) {
        return {
            'request': function (config) {
                if (config.url.indexOf(constant.api_url) > -1) {
                    $rootScope.$broadcast('loading:show');
                }
                return config;
            },
            'response': function (response) {
                // hack: I will not hide loading container when ajax response but will hide it when page has finished loading so 
                // there will be manual hide when calling api in the middle of the page
//        $rootScope.$broadcast('loading:hide');
                return response;
            }
        };
    });
});

skipQueueApp.controller('GlobalCtrl', function ($scope, $rootScope, $http, $state, $cordovaCamera, $ionicSideMenuDelegate, $ionicHistory, $q,
        Utilities, LocalDB, GlobalUser, GlobalRestaurant, ConnectionService, OrderCart, RestaurantService, 
        $ionicPlatform, $window, GlobalNotifications, ClockSrv, $ionicViewSwitcher, GlobalStaff) {

    LocalDB.init();
    $scope.page_name = page_name;
    $scope.language = constant.language;
    $scope.deviceInfo = null;
    $rootScope.currentPage = null;
    OrderCart.init();
    $scope.constant = constant;
    $scope.previousPage1 = null;
    $scope.previousPage2 = null;
    $scope.isGoingBack = false;

    Utilities.initDeviceInfo();

// Use for side menu
    var isSideMenuOpen = $scope.isSideMenuOpen = $ionicSideMenuDelegate.isOpen.bind($ionicSideMenuDelegate);
    var sideMenuWidth = $scope.sideMenuWidth = $(window).width() - ($(window).width() * 0.15);
//    $scope.setGlobalUser = function (user) {
//        $scope.globalUser = user;
//    };

    $scope.setPushWooshTag = function() {
        if($rootScope.pushNotification){
            $rootScope.pushNotification.setTags({
                        deviceName: "hello",
                        deviceId: 10
                    },
                    function(status) {
                        console.warn('setTags success');
                    },
                    function(status) {
                        console.warn('setTags failed');
                    }
            );
        }
    };


    // call setTag interval
    ClockSrv.startClock(function() {
        Utilities.getCurrentPositionWithoutErrorPopup().then(function (position) {
           $scope.setPushWooshTag();
        }, function (error) {
            // TODO: remove this when we cannot get current location, this code is for debug only
           //$scope.setPushWooshTag();
           // do nothing when cannot get location info
        });        
    });
    
    // Check if this is the first run of the app
    var getFlagOfFirstRun = $scope.getFlagOfFirstRun = function(){
        var dfd = $q.defer();
        LocalDB.get(constant.local_db_first_run).then(function(result){
            dfd.resolve(true);
        }, function(error){
            dfd.resolve(false);
        });
        
        return dfd.promise;
    };
    
    getFlagOfFirstRun().then(function(result){
        $rootScope.isFirstRun = result;
    });
    
    $scope.$on('$stateChangeStart', 
        function(event, toState, toParams, fromState, fromParams){ 
            if(toState.params && toState.params.skipGoingBack){
                if(fromState.params == null || (fromState.params && !fromState.params.skipGoingBack)){
                    if(!$scope.isGoingBack){
                        $scope.previousPage1 = fromState.name;
                        $scope.previousPage2 = fromState.name;
                    }
                    else{
                        $scope.previousPage1 = $scope.previousPage2;
                        $scope.previousPage2 = null;
                        if(toState.name === page_name.login && fromState.name !== page_name.signup){
                            $scope.isGoingBack = false;
                            event.preventDefault();
                            $scope.goPreviousHistory();
                            return;
                        }
                    }
                }
            }
            else{
                $scope.previousPage1 = null;
            }
            $scope.isGoingBack = false;
    });
    
    $scope.goBack = function () {           
        $ionicViewSwitcher.nextDirection('back');
        var currentView = $ionicHistory.currentView();
        
//        Utilities.showShortAlertError(constant.language.mess_title_error, currentView.stateName);
        
        if(currentView.stateName === page_name.index){
            $scope.isGoingBack = false;
            return;
        }
        
        $scope.isGoingBack = true;
        if(currentView.stateName === page_name.res_menu){
            var dishes = OrderCart.getCart().dishes;
            var nextPage = constant.is_skipque ? page_name.index : page_name.order_type;
            if(Object.keys(dishes).length){
                Utilities.showConfirm(constant.language.mess_title_warning, constant.language.msg_confirm_leave_res, function(res){
                    if(res){
                        $state.go(nextPage);
                    }
                });
            } else {
                $state.go(nextPage);
            }
        }
        else if(currentView.stateName === page_name.order_type) {
            if(constant.is_skipque) {
                var resName = GlobalRestaurant.getResName();
                if(resName.length === 0) {
                    $state.go(page_name.index);
                }else{
//                    $scope.goPreviousHistory(); // caoth
                    $state.go(page_name.res_menu);
                }
            }
            else {
                $state.go(page_name.search_cus);
            }
        } // HocOT - ticket 1171
        else if (currentView.stateName === page_name.category_show) {
            $state.go(page_name.res_menu);
        }
        else if (currentView.stateName === page_name.delivery_order_now ||
                currentView.stateName === page_name.delivery_order_advanced ||
                currentView.stateName === page_name.pickup_order_now ||
                currentView.stateName === page_name.pickup_order_later) {
            $state.go(page_name.order_type);
        }
        else{
            $scope.goPreviousHistory();
        }
    };
    
    $scope.goPreviousHistory = function(){
        
        if($scope.previousPage1 === null)
            $window.history.back();
        else
            $state.go($scope.previousPage1);
    };
    
    $ionicPlatform.registerBackButtonAction(function (event) {
        $scope.goBack();
    }, 100);

    $scope.getNumberOfDishInCart = function () {
        return OrderCart.getItemCount();
    };

    $scope.goToPage = function (pageKey) {
        $state.transitionTo(pageKey);
//        $state.go(pageKey);
    };
    $scope.goToPageWithParams = function (pageKey, params) {
//        $state.go(pageKey, params);
        $state.transitionTo(pageKey, params);
    };
    $scope.checkLogin = function () {
        var dfd = $q.defer();
        GlobalUser.getUser().then(function (data) {
            if (data && Utilities.emptyOrNull(data.user_id)) {
                dfd.resolve(true);
            }
            else {
                dfd.resolve(false);
            }
        });
        return dfd.promise;
    };
    $scope.openWeb = function (url) {
        window.open(url, "_system", 'location=yes');
    };
    $scope.errorHandler = function (err_obj) {
        Utilities.showAlertError(constant.language.mess_title_error, err_obj.message); // constant.language.mess_content_login_fb_error);
    };
    //not allow "Enter" and "Blank space" key
    $scope.keyPress = function (e) {
        if (e.which === 13 || e.which === 32) {
            e.preventDefault();
        }
    };
    //not allow "Enter" key
    $scope.keyPressAllowBlankSpace = function (e) {
        if (e.which === 13) {
            e.preventDefault();
        }
    };

    $scope.parseData = function (callback, obj) {
        return Utilities.parseData(callback, obj);
//        try {
//            var data = callback(obj);
//            return {
//                result: true,
//                obj: data
//            };
//        } catch (exc) {
//            return {
//                result: false,
//                obj: {
//                    errorCode: error_code.parse_data,
//                    message: error_message.parse_data
//                }
//            };
//        }
    };
    // parse data is success = true. 
    $scope.isParseDataSuccess = function (parseResult) {
        return Utilities.isParseDataSuccess(parseResult);
//        if (!parseResult.result) {
//            Utilities.showAlertError(constant.language.mess_title_error, err_obj.message);
//            return false;
//        }
//        return true;
    };
    $scope.logOut = function () {
        GlobalUser.getUser().then(function (user) {
            if (user) {
                //remove user in DB local
                GlobalUser.removeUser();
                //remove Notifications
                GlobalNotifications.clearAllNotifications();
                // Call API.
                var rawParams = [{prm_name: params_name.chain_id, prm_value: constant.chain_id},
                    {prm_name: params_name.user_id, prm_value: user.user_id}];
                ConnectionService.post(api_url.logout, rawParams).then(function (data) {
                }, function (error) {
                });
            }
        }, function (error) {
            $scope.isUserActive = false;
        });
        //Go to login.
        var params = [];
        Utilities.goBackToLogin(page_name.index, params);
        //$state.go(page_name.login);
    };
    
    $scope.logOutStaff = function () {
         GlobalStaff.getStaff().then(function (data) {
            if (data) {
                //remove user in DB local
                GlobalStaff.removeStaff();
                GlobalUser.getUser().then(function (user) {
                    if (user) {
                        //remove user in DB local
                        GlobalUser.removeUser();
                        //remove Notifications
                        GlobalNotifications.clearAllNotifications();
                        // Call API.
                        var rawParams = [{prm_name: params_name.chain_id, prm_value: constant.chain_id},
                            {prm_name: params_name.user_id, prm_value: user.user_id}];
                        ConnectionService.post(api_url.logout, rawParams).then(function (data) {}, function (error) {});
                    }
                }, function (error) {
                });
            }
        });
       
        //Go to login.
        Utilities.goBackToLogin(page_name.login, []);
        //$state.go(page_name.login);
    };
    
    // take a picture // move to utility
    $scope.takePicture = function (callback) {

        var dfd = $q.defer();
        var options = {
            quality: 75,
//            destinationType: Camera.DestinationType.DATA_URL,
            destinationType : Camera.DestinationType.DATA_URL,
            sourceType: Camera.PictureSourceType.CAMERA,
            saveToPhotoAlbum: true,
            allowEdit: true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 150,
            targetHeight: 150,
            popoverOptions: CameraPopoverOptions
        };
           
        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.imgUrl = constant.data_base64 + imageData;
            dfd.resolve(constant.data_base64 + imageData);
//            dfd.resolve(imageData);
        }, function (err) {
            // An error occured. Show a message to the user
            dfd.reject('error take pic');
        });
        return dfd.promise;
    };
    // choose a picture from galary // move to utility
    //    function UploadPicture(imageURI) {
    //        $scope.imageDataUrl = imageURI;
    //    }
    //    $scope.loadAvatarURL = function(imageDataUrl){
    //        return "data:image/jpeg;base64," + imageDataUrl;
    //    };
    // move to utility
    $scope.choosePictures = function (callback) {

        var dfd = $q.defer();
        var options = {
            quality: 75,
            destinationType: Camera.DestinationType.DATA_URL,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            allowEdit: true,
            encodingType: Camera.EncodingType.PNG,
            targetWidth: 150,
            targetHeight: 150,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false
        };
        $cordovaCamera.getPicture(options).then(function (imageData) {
            $scope.imgUrl = constant.data_base64 + imageData;
            dfd.resolve(constant.data_base64 + imageData);
        }, function (err) {
            // An error occured. Show a message to the user
            dfd.reject('error take pic');
        });
        return dfd.promise;
    };
    $scope.$watch(isSideMenuOpen, function (isOpen) {
        // do something
        $scope.isSideMenuOpen = isOpen;
    });
    $scope.stopPropagation = function ($event) {
        $event.stopPropagation();
    };
    $scope.createFullDate = function (date) {
        var day = date.getDate();
        var month = date.getMonth();
        var year = date.getFullYear();
        var hour = date.getHours();
        var minutes = date.getMinutes();
//        var seconds = date.getSeconds();

        return new Date(year, month, day, hour, minutes);
    };

    //liked/unliked for favourites, dish, find restaurant
    $scope.like = function (dish) {
        GlobalUser.getUser().then(function (data) {
            if (data && data.user_id) {
                var globalRes = GlobalRestaurant.getAll();
                dish.isLiked = !dish.isLiked;
                RestaurantService.favouriteItem(constant.chain_id, globalRes.resId, data.user_id, dish.id, dish.isLiked).then(function (data) {
                    //update dish.favCounter
                    if (dish.isLiked)
                        dish.favCounter++;
                    else
                        dish.favCounter--;
                    $rootScope.$broadcast('loading:hide');
                    $rootScope.$broadcast('changeLikedItem', dish);
                });
            }
            else {
                //go login
                //return current page. page has 
                //Utilities.goBackToLogin($state.current.name, $state.params);
                Utilities.showConfirm(constant.language.msg_login_required, constant.language.msg_login_to_continute, function (result) {
                    if (result) {
                        Utilities.goBackToLogin($state.current.name, $state.params);
                    }
                });
            }
        });
    };

    $scope.goToDishDetailPage = function (dish, subCatId) {
        if (dish.isActive) {
            $scope.goToPageWithParams(page_name.dish_detail, {dishId: dish.id, subCatId: subCatId});
        }
    };
    
    $scope.goToTrackOrderPage = function () {
        GlobalUser.getUser().then(function (result) {
            if (!result) {
                Utilities.showConfirm(constant.language.msg_login_required, constant.language.msg_do_you_want_login, function (res) {
                    if (res) {
                        Utilities.goBackToLogin(page_name.track_order, []);
                    }
                });
            } else {
                $scope.goToPage(page_name.track_order);
            }
        });
    };

    $scope.toogleRightMenu = function () {
        $ionicSideMenuDelegate.toggleRight(false);
    };
});
