skipQueueApp.controller('LoginCtrl', ['$scope', '$rootScope', '$state', 'ngFB', 'Validation', 'Utilities', 'ConnectionService',
    'UserService', 'GlobalUser', '$ionicPlatform', '$ionicSideMenuDelegate', '$stateParams', '$cordovaToast', 'StaffService', 'GlobalStaff',
    function ($scope, $rootScope, $state, ngFB, Validation, Utilities, ConnectionService, UserService,
            GlobalUser, $ionicPlatform, $ionicSideMenuDelegate, $stateParams, $cordovaToast, StaffService, GlobalStaff) {

        var previousPage = $stateParams.previousPage;

        $scope.back = function () {
            if (previousPage)
                $scope.goBack(previousPage);
        };

        // handle hard key back button for android
        var handleBack = $ionicPlatform.registerBackButtonAction(function (event) {
            event.preventDefault();
            $scope.back();
        }, 100);

        // then destroy it after finish
        $scope.$on('$destroy', handleBack);

        $scope.$on("$ionicView.beforeLeave", function () {
            $rootScope.$broadcast('loading:show');
        });

        $scope.$on("$ionicView.enter", function () {
            $rootScope.$broadcast('loading:hide');
        });

        $ionicSideMenuDelegate.toggleRight(false);

        $scope.user = {email: "", pass: ""};
	$scope.staff = {email: "", pass: ""};

        $scope.init = function () {
            $scope.data = {
                imgLogo: $rootScope.chain_logo, //TODO: /*imgLogo : angular.copy(UIService.loadLogo()),*/
                imgBackground: 'img/hoe-bg.jpg'
            };
            delete $rootScope.profile;
            console.log($rootScope.device_token);
        };

        $scope.keyPress = function (e) {
            if (e.which === 13 || e.which === 32) {
                if(constant.is_skipque) {
                    if (Utilities.emptyOrNull($scope.user.email) || !Utilities.emptyOrNull($scope.user.pass))
                        e.preventDefault();
                }
                else {
                    if (Utilities.emptyOrNull($scope.staff.email) || !Utilities.emptyOrNull($scope.staff.pass))
                        e.preventDefault();
                }
                
            }
        };

        $scope.signInClick = function () {
            //validation.validationEmail  & validation.validationPassword
            var strEmail = $.trim($scope.user.email);
            var strPass = $.trim($scope.user.pass);

            //deleted pass
            $scope.user.pass = '';

            // Validation.
            var val_email = Validation.validationEmail(strEmail);
            var val_pass = Validation.validationPassword(strPass);

            var arrError = [];
            if (!val_email.result)
                arrError.push(val_email.message);

            if (!val_pass.result)
                arrError.push(val_pass.message);

            if (arrError.length > 0) {
                var errObj = {errorCode: error_code.validation, message: arrError.join(' <br /> ')};
                $scope.errorHandler(errObj);
                return;
            }

            UserService.getSignIn(constant.chain_id, strEmail, strPass, $rootScope.device_token).then(function (data) {

                var userParse = $scope.parseData(UserService.parseLoginUserData, data);

                if (!$scope.isParseDataSuccess(userParse)) {
                    return;
                }
                // check empty for user_id. function isEmpty return true/false and object error 
                // Save user info.
                GlobalUser.init(userParse.obj);

                if ($rootScope.currentPage) {
                    goToLastVisitedPage();
                } else {//Goto HOME page.
                    $scope.goToPage(page_name.index);
                }
            }, function (error) {
                $scope.errorHandler(error);
            });
        };
        
        $scope.staffSignInClick = function () {
            //$scope.goToPage(page_name.search_cus);
            //validation.validationEmail  & validation.validationPassword
            var strEmail = $.trim($scope.staff.email);
            var strPass = $.trim($scope.staff.pass);

            //deleted pass
            $scope.staff.pass = '';
            
            // Validation.
            var val_email = Validation.validationEmail(strEmail);
            var val_pass = Validation.validationPassword(strPass);

            var arrError = [];
            if (!val_email.result)
                arrError.push(val_email.message);
            
            if (!val_pass.result)
                arrError.push(val_pass.message);

            if (arrError.length > 0) {
                var errObj = {errorCode: error_code.validation, message: arrError.join(' <br /> ')};
                $scope.errorHandler(errObj);
                return;
            }
            
            StaffService.getStaffSignIn(constant.chain_id, strEmail, strPass).then(function (data) {
                var staffParse = $scope.parseData(StaffService.parseLoginStaffData, data);
                if (!$scope.isParseDataSuccess(staffParse)) {
                    return;
                }
                // check empty for user_id. function isEmpty return true/false and object error 
                // Save user info.
                GlobalStaff.init(staffParse.obj);
                //$rootScope.staff = staffParse.obj;
                $scope.goToPage(page_name.search_cus);
            }, function (error) {
                $scope.errorHandler(error);
            });
        };

        $scope.fbLogin = function () {
            //TODO:Call Login FB, login fb by account fb, return token_id, email
            //      Save user info.
            //      check user login first.
            //      if(login first) -> save user info into globalUser & goto Sign Up page.
            //      else -> save data & Goto HOME page. TODO:

//            $(this).unbind("mouseenter mouseleave");

            ngFB.login({scope: 'public_profile,email,user_photos'}).then(
                    function (response) {
                        // If you want to get the profile picture please add the 'picture' to fieds
                        // for birthday you will need to add 'user_birthday' to scope and 'birthday' to fields but Facebook need to verify your reason to use the birthday
                        // and it depends on user settings that brithday may not return the year
                        ngFB.api({path: '/me', params: {'fields': 'id,first_name,last_name,email'}}).then(
                                function (user) {
                                    console.log(user);

                                    // caoth the button SignInWithFacebook stucks in hover state
                                    document.getElementById("txtEmail").focus();
                                    document.getElementById("txtEmail").blur();
                                    document.getElementById("btnFbSignIn").style.color = "white";

                                    if (user.email === "" || user.email === undefined) { // caoth
                                        var errObj = {errorCode: error_code.err_code_connection,
                                            message: error_message.login_fb_no_email};
                                        $scope.errorHandler(errObj);
                                        return;
                                    }

                                    UserService.getSignInWithFB(constant.chain_id, user.id, user.email, constant.social_type_fb, $rootScope.device_token).then(function (data) {
                                        if (data)
                                        {
                                            $rootScope.$broadcast('loading:hide'); // caoth
                                            var userParse = $scope.parseData(UserService.parseLoginUserData, data);
                                            if (!$scope.isParseDataSuccess(userParse)) {
                                                return;
                                            }
                                            if (userParse.obj)
                                            {
                                                GlobalUser.init(userParse.obj);
                                                $scope.goToPage(page_name.index);
                                            }
                                        } else {
                                            $rootScope.$broadcast('loading:hide'); // caoth                                            
                                            ngFB.api({
                                                path: '/me/picture',
                                                params: {
                                                    redirect: false,
                                                    height: 150,
                                                    width: 150
                                                }
                                            }).then(function (res) {
//                                                angular.extend(me, {picture: res.data.url});
                                                console.log('login: ' + res.data.url);
                                                $scope.goToPageWithParams(page_name.signup, {email: user.email, social_id: user.id, avatar: res.data.url, firstName: user.first_name, lastName: user.last_name});
                                            });

//                                            $scope.goToPageWithParams(page_name.signup, {email: user.email, social_id:user.id});
                                        }
                                    }, function (error) {
                                        $scope.errorHandler(error);
                                    });
                                },
                                function (error) {
//                                    document.getElementById("txtEmail").focus();
                                    var errObj = {errorCode: error_code.err_code_connection,
                                        message: constant.language.mess_content_login_fb_error};
                                    $scope.errorHandler(errObj);
                                });
                    },
                    function (error) {
                        $rootScope.$broadcast('loading:hide');
                        document.getElementById("txtEmail").focus();
                        document.getElementById("txtEmail").blur();
//                        document.getElementById("lkSignUp").focus();
//                        document.getElementById("txtEmail").value = "My value";
//                        document.getElementById("txtEmail").select();
//                        document.getElementById("btnSignIn").focus();
//                        document.getElementById("btnFbSignIn").style.color = "white";

//                        document.getElementById("bugCheckBox").focus();

                        document.getElementById("btnFbSignIn").style.color = "white";

                        var errObj = {errorCode: error_code.err_code_connection,
                            message: error_message.login_fb};
                        $scope.errorHandler(errObj);
                    });
        };

        $scope.showForgotPass = function () {
            $scope.user.email = '';
            //Show popup 
            $scope.cordovaToast = $cordovaToast;
            var template = '<div class="list">' +
                    '<label class="center"> <h3 class="medium-text">Please enter your email id and we will send you a link to update password</h3></label>' +
                    '<label class="item-input-wrapper"><input class="center" type="text" placeholder="Enter e-mail" ng-model="user.email" style="width: 100%; background-color: transparent !important;" /></label></div>';

            var buttons = [
                {text: constant.language.btn_cancel,
                    type: 'button-default',
                    onTap: function (e) {
                        $state.go(page_name.index);
                    }
                },
                {
                    text: '<b>' + constant.language.btn_change_pass + '</b>',
                    type: 'button-default',
                    onTap: function (e) {
                        var strEmail = $.trim($scope.user.email);
                        // Validation.
                        var val_email = Validation.validationEmail(strEmail);
                        if (!val_email.result) {
                            e.preventDefault();
                            if (window.cordova) {
                                $cordovaToast.showShortBottom(val_email.message).then(function (success) {
                                    // success  
                                }, function (error) {
                                    // error
                                });
                            } else {
                                console.log('invalid email');
                            }
//                            Utilities.showAlertErrorCallback(constant.language.mess_title_error, val_email.message, function(){showForgotPass();});
//                            Utilities.showAlert(constant.language.mess_title_error, val_email.message);

//                            Utilities.showAlert(constant.language.mess_title_error, val_email.message);
//                            Utilities.showAlertErrorCallback(constant.language.mess_title_error, val_email.message, 
//                                function(){showForgotPass();});
                        } else {
                            // Click Change pass button, call api forgot change pass
                            var rawParams = [{prm_name: params_name.chain_id, prm_value: constant.chain_id},
                                {prm_name: params_name.user_email, prm_value: strEmail}];
                            $rootScope.$broadcast('loading:show');
                            ConnectionService.post(api_url.forgot_password, rawParams).then(function (data) {
                                $rootScope.$broadcast('loading:hide');
                                var buttons_child = [{text: constant.language.btn_dismiss,
                                        type: 'button-default',
                                        onTap: function (e) {
                                            return;
                                        }
                                    }, {text: constant.language.btn_home,
                                        type: 'button-default',
                                        onTap: function (e) {
                                            $scope.goToPage(page_name.index);
                                        }
                                    }];
                                Utilities.showPopup($scope, constant.language.msg_change_pass_success + strEmail, "", buttons_child);
                                return;

                            }, function (error) {
                                $rootScope.$broadcast('loading:hide');
                                if (error.errorCode === constant.code_email_not_exist) {
                                    // goto sign up with 
                                    $scope.errorHandler(error);
                                    $scope.goToPageWithParams(page_name.signup, {email: $scope.user.email});
                                } else {
                                    $scope.errorHandler(error);
                                }
                            });
                        }
                    }
                }
            ];
            //msg_content_forgot_pass
            Utilities.showPopup($scope, constant.language.lbl_title_change_pass, template, buttons);
        };

        var goToLastVisitedPage = function () {
            var obj = $rootScope.currentPage;

            if (obj !== null) {
                $rootScope.currentPage = null;
                if (Object.keys(obj.params).length > 0) {
                    $scope.goToPageWithParams(obj.currentName, obj.params);
                } else {
                    $scope.goToPage(obj.currentName);
                }
            }
        };

        $scope.init();
    }]);