skipQueueApp.controller('MakePaymentCtrl', function ($rootScope, $scope, $rootScope, GlobalUser, 
                            RestaurantService, OrderCart, data, $http, Utilities, 
                            $ionicPlatform, $rootScope, $cordovaInAppBrowser, GlobalStaff) {
    var orderCart = OrderCart.getCart();
    var user = null;
    GlobalUser.getUser().then(function (gbUser) {
        user = gbUser;
    });
    $scope.init = function () {
        var parseResult = $scope.parseData(RestaurantService.parseDataPaymentMethod, data);
        if (!$scope.isParseDataSuccess(parseResult)) {
            return;
        }
        $scope.grandTotal = orderCart.grandTotal;
        $scope.currency = orderCart.currency;
        $scope.paymentList = parseResult.obj;
    };
    
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });    

    $scope.doTransaction = function (payment) {
        $rootScope.$broadcast('loading:show');
        
        GlobalStaff.getStaff().then(function (staff) {
            var staffId = staff === null ? '' : staff.staff_id;
            // if this payment is cash then do post data
            if(payment.type == constant.cash_payment_type){    
                var rawParams = [{
                        prm_name: params_name.chain_id,
                        prm_value: constant.chain_id
                    }, {
                        prm_name: params_name.restaurant_id,
                        prm_value: orderCart.resId
                    }, {
                        prm_name: params_name.total_amount,
                        prm_value: $scope.grandTotal
                    }, {
                        prm_name: params_name.order_id,
                        prm_value: orderCart.orderId
                    }, {
                        prm_name: params_name.customer_id,
                        prm_value: user.user_id
                    },{
                        prm_name: params_name.payment_type,
                        prm_value: constant.cash_payment_type
                    },{
                        prm_name: params_name.staff_id,
                        prm_value: staffId
                    }];

                var sendData = Utilities.prepareParams(rawParams);

                //$scope.goToPage(page_name.payment_success); for test purpose
                $rootScope.$broadcast('loading:show');
                $http.post(api_url.cash_payment, sendData).then(function (res) {
                    $rootScope.$broadcast('loading:hide');
                    // Check result true or false
                    if (res.data.result) {
                        $scope.goToPage(page_name.payment_success);
                    } else {
                        Utilities.showAlertError(constant.language.err_msg.mess_title_error, res.data.message);                
                    }
                }, function (error) {
                    $rootScope.$broadcast('loading:hide');
                    Utilities.showAlertError(constant.language.err_msg.mess_title_error, error_message.connection);
                });
            }else{            
                var rawParams = [{
                        prm_name: params_name.chain_id,
                        prm_value: constant.chain_id
                    }, {
                        prm_name: params_name.restaurant_id,
                        prm_value: orderCart.resId
                    }, {
                        prm_name: params_name.total_amount,
                        prm_value: $scope.grandTotal
                    }, {
                        prm_name: params_name.order_id,
                        prm_value: orderCart.orderId
                    }, {
                        prm_name: params_name.user_id,
                        prm_value: user.user_id
                    },{
                        prm_name: params_name.staff_id,
                        prm_value: staffId
                    }];

                var sendData = Utilities.prepareParams(rawParams);

                //$scope.goToPage(page_name.payment_success); for test purpose
                $rootScope.$broadcast('loading:show');
                $http.get(payment.baseUrl, {params: sendData}).then(function (res) {
                    $rootScope.$broadcast('loading:hide');
                    // Check result true or false
                    if (res.data.result) {
                        redirectToPaymentPage(res.data.data);
                    } else {
                        if(res.data.code == constant.PAYMENT_EXPIRED_ERROR_CODE){
                            Utilities.showPopupAlertError(constant.language.err_msg.title_error, res.data.message, function (result) {
                                if (result) {
                                    $scope.goToPageWithParams(page_name.confirm_detail, {payment_expired: true}); //(page_name.confirm_detail); // go back to confirm payment page
                                    // TODO: check if we have error enter this page -> if yes go to menu with order cart open
                                }
                            });
                        }else{
                            Utilities.showAlertError(constant.language.err_msg.mess_title_error, res.data.message);
                        }    
                    }
                }, function (error) {
                    $rootScope.$broadcast('loading:hide');
                    Utilities.showAlertError(constant.language.err_msg.mess_title_error, error_message.connection);
                });
            }
        })
    };

    var redirectToPaymentPage = $rootScope.redirecToPayment = function (data) {
        //TODO: Implement do transaction
        var options = {
            location: 'no',
            clearcache: 'yes',
            toolbar: 'no'
        };
        //data.redirect_url
        //     
        
        $ionicPlatform.ready(function() {
            $cordovaInAppBrowser.open(data.redirect_url, '_blank', options);
                $rootScope.$on('$cordovaInAppBrowser:loadstart', function(e, event){                                 
                    if(event.url.indexOf(constant.skipqueue_3_0_pay_succeeded) > -1) {                
                        $cordovaInAppBrowser.close();

                        //alert('Pay successfully');
                        //$scope.goToPage(page_name.res_menu);
                        $scope.goToPage(page_name.payment_success);
                    }
                    else if(event.url.indexOf(constant.skipqueue_3_0_pay_failed) > -1) {
                        $cordovaInAppBrowser.close();

                        //alert('Pay cancelled');
                        Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.payment_failed);
                        //$scope.goToPage(page_name.res_menu);
                    }
                });
        });
        
    };
});