skipQueueApp.controller('OrderListCtrl', function ($rootScope, $scope, $state, GlobalRestaurant, OrderCart, Utilities, $ionicSideMenuDelegate, PromotionSrv, $ionicViewSwitcher, OrderService) {
    $scope.init = function () {
        $scope.isShowGuide = true;
        $scope.guide = constant.language.msg_cart_guide;
        $scope.orderCart = OrderCart.getCart();
        $scope.orderType = Utilities.getOrderTypeNameById($scope.orderCart.selectedOrderType);
        $scope.promotion = $scope.orderCart.promotion ? angular.copy($scope.orderCart.promotion) : {code : ''};
        $scope.promotion.code = '';
    };
    
    $scope.getItemCount = function(){
        return OrderCart.getItemCount();
    };
    
    $scope.notHasPromotion = function(){
        return (GlobalRestaurant.getNumberOfPromotions() === 0 || OrderCart.getItemCount() <= 0);
    };
    
    
    
    $scope.displayStrCustomisations = function (listOfCustomisations) {
        var listOfCustomisationsName = [];
        angular.forEach(listOfCustomisations, function (custom) {
            listOfCustomisationsName.push(custom.name);
        });

        return listOfCustomisationsName.join(', ');
    };

    $scope.hideGuide = function () {
        var buttons = [
            {text: 'Cancel'},
            {
                text: 'Turn Off',
                type: 'button',
                onTap: function (e) {
                    $scope.isShowGuide = false;
                    $scope.resetHeight();
                }
            }
        ];
        Utilities.showPopup($scope, constant.language.title_hints, constant.language.mess_close_guide, buttons);
    };

    $scope.leftBarClick = function () {
        $state.go(page_name.res_menu);
    };

    $scope.delete = function (id) {
        Utilities.showConfirm(constant.language.mess_title_warning,constant.language.msg_are_you_sure, function(result){
            if(result){
                delete OrderCart.removeFromCart(id);
            }
        });
    };

    $scope.edit = function (dish) {
        // Return to dish detail page
        if($state.params.guid === dish.guid){
            $ionicSideMenuDelegate.toggleRight(false);
            return;
        }
        $scope.goToPageWithParams(page_name.dish_detail, {
            dishId: dish.id,
            guid: dish.guid,
            isRecommendation: dish.isRecommendation,
            cusId: dish.cusId,
            parentId: dish.parentId
        });
    };

    $scope.goToConfirmOrderPage = function () {    
        $scope.checkLogin().then(function (data) {
            if(data){
                $ionicViewSwitcher.nextTransition('none');
                //$scope.goToPage(page_name.confirm_detail);
                $scope.goToPageWithParams(page_name.confirm_detail, {'payment_expired': false});
            }else{
                Utilities.showConfirm(constant.language.msg_login_required, constant.language.msg_login_to_continute, function (result) {
                    if (result) {
                        var currentName = page_name.confirm_detail;
                        var params = {'payment_expired': false};      
                        Utilities.goBackToLogin(currentName, params);
                    }
                });
            }            
        });
    };

    $scope.clearPromotionKey = function () {
        $scope.promotion.code = '';
    };

    $scope.applyPromotion = function () {
        if(Utilities.isHasPromotionApplied()){
            Utilities.showConfirm(constant.language.mess_title_warning, constant.language.msg_change_promotion, function(result){
                if(result){
                    PromotionSrv.applyPromotion($scope.promotion).then(function(result){
//                        $rootScope.$broadcast('loading:hide'); // caoth
                    }, function(error){
//                        $rootScope.$broadcast('loading:hide');
                        Utilities.showAlertError(constant.language.mess_title_error, error.message);
                    });
                }
                else {
                    return;
                }
            });    
        } else {
            PromotionSrv.applyPromotion($scope.promotion).then(function(result){
//                Utilities.turnOffIndicator($scope); // caoth
            }, function(error){
                Utilities.showAlertError(constant.language.mess_title_error, error.message);
            });
        }
    };
    
    $scope.resetHeight = function(){
        $('.cart-content').css('cssText', 'margin-top: 0px !important; top: 50px !important;');
    };
    
    $scope.goToPromotionsPage = function(){
        $scope.goToPage(page_name.promotion_list);
        $scope.toogleRightMenu();
    };
    
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });
    
    $scope.init();
});