skipQueueApp.controller('PastOrderDetailCtrl', function($scope, $rootScope, Order, Bill, Utilities, OrderService, GlobalUser, CommonService, order){
    $scope.init = function(){
        var parseResult = $scope.parseData(OrderService.parseDataOrderDetail, order);
        if (!$scope.isParseDataSuccess(parseResult)) {
            return;
        }
        // success case
        $scope.order = angular.copy(parseResult.obj);
        $scope.dishes = $scope.order.bill.dishes;
        $scope.bill = $scope.order.bill;
    };
    
    $scope.emailReceipt = function(){
        var orderId = $scope.order.id;
        var orderTypeId = $scope.order.orderTypeId;
        GlobalUser.getUser().then(function(user){
            if(user){
                $rootScope.$broadcast('loading:show');
                CommonService.sendEmailReceipt(user.user_id, orderId, orderTypeId).then(function(result){
                    $rootScope.$broadcast('loading:hide');
                    var msg = constant.language.msg_send_email_success_first_part + ' ' + $scope.order.number + ' '
                            + constant.language.msg_send_email_success_second_part + ' ' + user.email;
                    var buttons = [
                        {
                            text: 'Dismiss',
                            type: 'button'
                        }, {
                            text: 'Home',
                            type: 'button',
                            onTap: function () {
                                $scope.goToPage(page_name.index);
                            }
                        }
                    ];
                    Utilities.showPopup($scope, '', msg, buttons);
                }, function(error){
                    $rootScope.$broadcast('loading:hide');
                    Utilities.showAlertError(constant.language.err_msg.mess_title_error, error.message);
                });
            }
        });
    };
    
    Utilities.turnOffIndicator($scope);
});