/* global constant */

skipQueueApp.controller('PickupCtrl', function ($rootScope, $scope, $state, $filter, GlobalRestaurant, Utilities, Validation,
        GlobalUser, OrderTypeService, OrderCart) {
    $scope.del_order = {
        user_id: '',
        phone: '',
        delivery_date: new Date(),
        delivery_time: null //$scope.createFullDate(new Date())
    };
    $scope.init = function () {
        var globalRes = GlobalRestaurant.getAll();
        var arrOrderTypes = globalRes.orderTypes;
        if (arrOrderTypes.length > 0) {
            $scope.ordertype_child = OrderTypeService.parsePickupChildFromOrderTypeInRes(arrOrderTypes);
        }
        else {
            $scope.ordertype_child = {isNow: true, isLater: true};
        }
        //get user from local DB.
        GlobalUser.getUser().then(function (data) {
            if (Utilities.emptyOrNull(data) && Utilities.emptyOrNull(data.user_id)) {
                $scope.user = data;
                $scope.del_order.phone = data.phone;
                $scope.del_order.user_id = data.user_id;
            }
            else {
//                if(globalRes && Utilities.emptyOrNull(globalRes.resId)){
//                    $state.go(page_name.login);
//                }
            }
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            return;
        });
        
    };
    
    $scope.continueButtonOfNow = function (isValid) {
        if(!isValidPhone()){
            return ;
        };
        if (isValid) {
        
            OrderTypeService.checkSupportedOrderType(constant.order_type_child_pickup_now, null, null, function(){
                OrderCart.setSelectedOrderType(constant.order_type_child_pickup_now);
                OrderCart.setPhone($scope.del_order.phone);

                var globalRes = GlobalRestaurant.getAll();
                var resId = globalRes.resId;
                //if restaurant Id not exist, go to find res. of pickup 
                if (!Utilities.emptyOrNull(resId)) {
                    $scope.goToPage(page_name.res_pickup);
                    return;
                }

                //if restaurant Id exists  
                
                // caoth recommendation page
                var dish = OrderCart.getCart().tempItem;
                if(dish !== null) {                    
                    if (dish.selectedSku.hasRecommendation && !dish.isRecommendation) {
                        $scope.goToPageWithParams(page_name.dish_recommendations, {dishId: dish.id, parentId: dish.guid});                        
                        OrderCart.clearTempItem();
                        return;
                    }
                }

                // goto res. menu     
                $scope.goToPage(page_name.res_menu);
            });
        } else {
            console.log('Not valid');
        }
    };

    $scope.continueButtonOfLater = function (isValid) {
        if(!isValidTime()){
            return ;
        };
        if(!isValidPhone()){
            return ;
        };
        if (isValid) {
            if (validateForm()) {
                
            OrderTypeService.checkSupportedOrderType(constant.order_type_child_pickup_later, $scope.del_order.delivery_date.toDateString(), $scope.del_order.delivery_time.toTimeString(), function(){
                OrderCart.setSelectedOrderType(constant.order_type_child_pickup_later);
                OrderCart.setDateTime(Utilities.formatDateTime(constant.formatDateTime, new Date($scope.del_order.delivery_date.toDateString() + ' ' + $scope.del_order.delivery_time.toTimeString())));
                // ToDo caoth: client time should not show
                OrderCart.setPhone($scope.del_order.phone);

                var globalRes = GlobalRestaurant.getAll();
                var resId = globalRes.resId;
                //if restaurant Id not exist, go to find res. of pickup 
                if (!Utilities.emptyOrNull(resId)) {
                    $scope.goToPage(page_name.res_pickup);
                    return;
                }

                //if restaurant Id exists 
                
                // caoth recommendation page
                var dish = OrderCart.getCart().tempItem;
                if(dish !== null) {                    
                    if (dish.selectedSku.hasRecommendation && !dish.isRecommendation) {
                        $scope.goToPageWithParams(page_name.dish_recommendations, {dishId: dish.id, parentId: dish.guid});                        
                        OrderCart.clearTempItem();
                        return;
                    }
                }

                // goto res. menu        
                $scope.goToPage(page_name.res_menu);
            });
            }
        }
    };

    var validateForm = function () {
        //var datetime = new Date($scope.del_order.delivery_date.toDateString() + ' ' + $scope.del_order.delivery_time.toTimeString());
        
        var datetime = moment($scope.del_order.delivery_date.toDateString() + ' ' + $scope.del_order.delivery_time.toTimeString()).format(constant.parse_time_format);
        
        if (!Validation.isAfterNow(datetime)) {
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.time_before_now);
            return false;
        }

        return true;
    };
    
    var isValidPhone = function(){
        if($scope.del_order.phone == '' || !$scope.del_order.phone){
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.phone_required);
            return false;
        }
        
        var valid = Validation.validationPhone($scope.del_order.phone);
        if(!valid.result){
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, valid.message);
            return false;
        }
        
        return true;
    };
    
    var isValidTime = function(){
         if ($scope.del_order.delivery_time == '' || !$scope.del_order.delivery_time) {
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.del_time_required);
            return false;
        }
        return true;
    };
    
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });
    
    $scope.init();
});




