/* global skipQueueApp */
skipQueueApp.controller('ProfileCtrl', function ($rootScope, $scope, $ionicScrollDelegate, $ionicActionSheet, $timeout, $filter
        , Utilities, UserService, GlobalUser, $state, CommonService, profileInfo, Validation, GlobalStaff) {
    $scope.isMouseOverChange = false;
    $scope.isModeEdit = false;
    $scope.indexAddressEdit = -1;

    $scope.profile_view = {};
    $scope.profile = {};

    $scope.countries = [];
    $scope.cities = [];
    $scope.states = [];
    $scope.types = constCommonObj.arr_types;
    $scope.addressLoadFirst = [];

    $scope.init = function () {
        CommonService.getCountry().then(function (data) {
            // Parse data
            $scope.countries = angular.copy(data);
        }, function (error) {
            $scope.errorHandler(error);
        });
        //$scope.countries = UserService.getCountries();
        //get user from local DB.
        $scope.profile_view = angular.copy(profileInfo);//userParse.obj
        $scope.addressLoadFirst = angular.copy(profileInfo.address);
    };

    $scope.addAddressClick = function () {
        $scope.profile.address.push({'country': {name: constant.country_default, id: -1},
            'countries': $scope.countries,
            'state': {name: constant.state_default, id: -1},
            'states': [],
            'city': {name: constant.city_default, id: -1},
            'cities': [],
            'address': '',
            'block_code': '',
            'zip_code': '',
            'type': {},
            'types': constCommonObj.arr_types,
            'id': "-1",
            'has_change': "0",
            'is_delete': "0",
            'unit_no': "",
            'address_2': ""});
        $ionicScrollDelegate.scrollBottom();
    };

    $scope.updateClick = function (userId) {
        //+ Loading, show blank password
        //+ If user don't input password, meaning is no change
        //+ If user input password, meaning is user want to change password and validate password.
        //success goto profile view page
        if (!validation($scope.profile))
            return;

        //check the address emply in profile.address 
        var arrAddressEmpty = [];
        for (var i = 0; i < $scope.profile.address.length; i++) {
            if (Utilities.isAddressEmpty($scope.profile.address[i])) {
                arrAddressEmpty.push(i);
            } else {
                if (!Validation.validationAddressAtIndex($scope.profile.address[i], (i + 1))) {
                    return;
                }
                var validationZipcode = Validation.validationZipCode($scope.profile.address[i].zip_code);
                if (!validationZipcode.result) {
                    Utilities.showAlertError(constant.language.mess_title_error + " " + constant.language.lbl_address + (i + 1).toString(), validationZipcode.message);
                    return;
                }
            }
        }
        if (arrAddressEmpty && arrAddressEmpty.length > 0) {
            angular.forEach(arrAddressEmpty, function (item) {
                $scope.profile.address.splice(item, 1);
            });
        }
        $scope.profile.address = UserService.compareAddressEdit($scope.addressLoadFirst, $scope.profile.address);

        $scope.profile.avatar = angular.copy($scope.profile.avatar.replace(constant.data_base64, ""));

        $scope.profile.birthday = angular.copy(Utilities.formatDateTime(constant.formatDate, $scope.profile.birthday));
        
        GlobalStaff.getStaff().then(function (data) {
            var staffId = data == null ? '' : data.staff_id;
            UserService.updateProfile(constant.chain_id, $scope.profile, staffId).then(function(data){
                    //update image avatar
                    var userParse = Utilities.parseData(UserService.parseLoginUserData, data);
                    if (!userParse.result) {
                        return;
                    }
                    $scope.profile_view  = userParse.obj;
                    GlobalUser.init(userParse.obj);
                    $scope.isModeEdit = false;
                    $rootScope.$broadcast('loading:hide');             
                }, function(error){
                    $rootScope.$broadcast('loading:hide');
                    $scope.errorHandler(error);

            });
        });        
    };

    $scope.validationDateBirth = function () {
        if (!UserService.validationDateBirth($scope.profile.birthday)) {
            $scope.profile.birthday = new date();
            return;
        }
    };

    $scope.removeAddressClick = function (index) {
//            Utilities.showConfirm('',constant.language.msg_delete_address, function(result){
//                if(result){
//                    if($scope.profile.address[index].id < 0 || Utilities.isAddressEmpty($scope.profile.address[index])){
//                        $scope.profile.address.splice(index);
//                    }
//                    else{
//                        $scope.profile.address[index].is_delete = "1";
//                    }
//                }
//            });
        var buttons = [
            {text: 'Cancel'},
            {
                text: '<b class="b1_body_text_red">Delete</b>',
                type: 'button button-stable',
                onTap: function () {
                    if ($scope.profile.address[index].id < 0 || Utilities.isAddressEmpty($scope.profile.address[index])) {
                        $scope.profile.address.splice(index);
                    } else {
                        $scope.profile.address[index].is_delete = "1";
                    }
                }
            }
        ];
        Utilities.showPopup($scope, '', constant.language.msg_delete_address, buttons);
    };

    $scope.edit = function () {
        //$scope.profile  = angular.copy($scope.profile_view);
        //parse address from model to viewmodel
        UserService.parseAddressData($scope.profile_view.address).then(function (addressVM) {
            $scope.isModeEdit = true;
            $scope.profile = angular.copy($scope.profile_view);
            if (addressVM) {
                $scope.profile.address = angular.copy(addressVM);
            }
            $rootScope.$broadcast('loading:hide');
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
        });
    };

    $scope.loadState = function (address) {
        CommonService.getState(address.country.id).then(function (data) {
            address.states = angular.copy(data);
            address.state = {name: constant.state_default};
            address.city = {name: constant.city_default};
            address.cities = [];
            $rootScope.$broadcast('loading:hide');
            //$scope.currentUser.text = $scope.currentUser.collections.field[ind].value;
        }, function (error) {
            $scope.errorHandler(error);
            $rootScope.$broadcast('loading:hide');
        });
    };

    $scope.loadCity = function (address) {
        CommonService.getCity(address.state.id).then(function (data) {
            address.cities = angular.copy(data);
            address.city = {name: constant.city_default};
            $rootScope.$broadcast('loading:hide');
        }, function (error) {
            $scope.errorHandler(error);
            $rootScope.$broadcast('loading:hide');
        });
    };

    // for change avata
    $scope.show = function () {
        // Show the action sheet
        var hideSheet = $ionicActionSheet.show({
            buttons: [
                {text: '<b>Take a picture</b>'},
                {text: '<b>Choose from gallery </b>'}
            ],
            titleText: 'Add your avatar',
            cancelText: 'Cancel',
            cancel: function () {
                // add cancel code..
            },
            buttonClicked: function (index) {
                if (index === 0) {
                    $scope.takePicture($scope.loadAvatarURL).then(function (data) {
                        $scope.profile.avatar = data;
                        return true;
                    }, function (error) {
                        console.log('11');
                    });
                    //$scope.takePicture($scope.loadAvatarURL);
                }
                if (index === 1) {
                    $scope.choosePictures($scope.loadAvatarURL).then(function (data) {
                        $scope.profile.avatar = data;
                        return true;
                    }, function (error) {
                        console.log('11');
                    });
                    //$scope.choosePictures($scope.loadAvatarURL);
                    //$scope.profile.avatar = $scope.imageDataUrl;
                }
                return true;
            }
        });

        // hide the sheet after two seconds
        $timeout(function () {
            hideSheet();
        }, 5000);
    };

    $scope.continueProfile = function () {
        $scope.goToPage(page_name.order_type);
    };

    function validation(profile) {
        var arrError = [];
        if (!profile.first_name || !profile.phone) {
            $scope.errorHandler({errorCode: error_code.validation, message: constant.language.mess_content_check_info_highlight_in_red});
            return false;
        }
        if (constant.is_skipque) {
            if (!profile.email || !profile.birthday || !profile.last_name) {
                $scope.errorHandler({errorCode: error_code.validation, message: constant.language.mess_content_check_info_highlight_in_red});
                return false;
            }
            
            //        var val_email = constant.is_skipque ? Validation.validationEmail(profile.email) : Validation.validationEmailNoRequired(profile.email);
            var val_email = Validation.validationEmail(profile.email);
            if (!val_email.result)
                arrError.push(val_email.message);
        }

        if (profile.birthday) {
            profile.birthday = angular.copy(Utilities.formatDateTime(constant.formatDateTime, profile.birthday));
            if (!UserService.validationDateBirth(profile.birthday)) {
                return false;
            }
        }

        if (profile.phone) {
            var val_phone = Validation.validationPhone(profile.phone);
            if (!val_phone.result) {
                Utilities.showAlertError(constant.language.mess_title_error, val_phone.message);
                return false;
            }
        }
        //check comfirm pass with password
        if (angular.isUndefined(profile.pass)) {
            profile.pass = "";
        }
        if (profile.pass) {
            var val_pass = Validation.validationPassword(profile.pass);//Pass text length at least 8 characters. 
            if (!val_pass.result) {
                Utilities.showAlertError(constant.language.mess_title_error, val_pass.message);
                return false;
            }
            if ($scope.profile.confirm === "") {
                Utilities.showAlertError(constant.language.mess_title_error, constant.language.mess_input_comfirm_new_pass);
                return false;
            } else {
                if (profile.pass !== profile.confirm) {
                    Utilities.showAlertError(constant.language.mess_title_error, constant.language.mess_pass_do_not_match);
                    //alert("Must match the previous entry");
                    $scope.profile.confirm = "";
                    return false;
                }
            }
        }

        //check image 
        if (profile.avatar.indexOf(constant.data_base64) === -1) {//not exist == -1
            profile.avatar = "";
        } else {
            profile.avatar = profile.avatar.replace(constant.data_base64, "");
        }
        if (arrError.length > 0) {
            var errObj = {errorCode: error_code.validation, message: arrError.join(' <br /> ')};
            $scope.errorHandler(errObj);
            return false;
        }
        return true;
    }

    $scope.$on("$ionicView.beforeLeave", function () {
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function () {
        $rootScope.$broadcast('loading:hide');
    });

    $scope.init();

});
