skipQueueApp.factory('DeliveryRestaurantViewModel', function () {
    var DeliveryRestaurantViewModel = function (sumaryRestaurantArr, availableRestaurantArr, unavailableRestaurantArr) {
        this.summaryAvailableRestaurantArr = sumaryRestaurantArr;
//        this.availableRestaurantArr = availableRestaurantArr;
//        this.unavailableRestaurantArr = unavailableRestaurantArr;
    };

    return DeliveryRestaurantViewModel;
});

skipQueueApp.controller('RestaurantDeliveryController', function ($rootScope, $scope, GlobalRestaurant, $filter, $ionicScrollDelegate,
        restaurants, DeliveryRestaurantViewModel, Paging, RestaurantService) {
            
    var parseDataToViewModel = function (model) {
        var parseResult = $scope.parseData(RestaurantService.parseDataFindResOfDelivery, model);
        
        if (!$scope.isParseDataSuccess(parseResult)) {
            return;
        }
        
        var viewModel = parseResult.obj;
        
        $scope.originAvailableList = angular.copy(viewModel.availableList);
        $scope.originUnAvailableList = angular.copy(viewModel.unavailableList);
        var arrSumaryRes = viewModel.availableList.concat(viewModel.unavailableList);
        $scope.arrAvailableLenght = viewModel.availableList.length;
        $scope.Paging = new Paging(arrSumaryRes);
        return new DeliveryRestaurantViewModel($scope.Paging.loadMore(), viewModel.availableList, viewModel.unavailableList);
    };

    $scope.init = function () {
        $scope.restaurantVM = parseDataToViewModel(restaurants);
        $scope.originSummaryAvailableRestaurants = angular.copy($scope.restaurantVM.summaryAvailableRestaurantArr);
    };

    var searchRestaurantByName = function (arr, name) {
        //return $filter('filter')(arr, {name: name, cuisineType:name});
        return arr.filter(function (restaurant) {
            return restaurant.name.toLowerCase().indexOf(name.toLowerCase()) >= 0
                    || restaurant.cuisineType.toLowerCase().indexOf(name.toLowerCase()) >= 0;
        });
    };

    $scope.keyPress = function (e) {
        if (e.which === 13 || e.which === 32) {
            //e.preventDefault();
            if ($scope.searchName || $scope.searchName === '') {
                if ($scope.searchName === '') {
                    $scope.clearSearch();
                } else {                    
                    var result = searchRestaurantByName(angular.copy($scope.originAvailableList), $scope.searchName);
                    var resultUnavalible = searchRestaurantByName(angular.copy($scope.originUnAvailableList), $scope.searchName);
                    //search on Unavailable Restaurants
                    $scope.arrAvailableLenght = result.length;
                    $scope.restaurantVM.summaryAvailableRestaurantArr = result.concat(resultUnavalible);
                    $scope.Paging.init($scope.restaurantVM.summaryAvailableRestaurantArr);
                }
                $ionicScrollDelegate.scrollTop();
            }
            cordova.plugins.Keyboard.close();
        }
    };

    $scope.clearSearch = function () {        
        var result = angular.copy($scope.originAvailableList); //$scope.originSummaryAvailableRestaurants);
        //search on Unavailable Restaurants
        var resultUnavalible = angular.copy($scope.originUnAvailableList); //$scope.originUnavailableRestaurants);
        $scope.arrAvailableLenght = result.length;
        $scope.restaurantVM.summaryAvailableRestaurantArr = result.concat(resultUnavalible);
        
        $scope.searchName = '';
        
        $scope.Paging.init($scope.restaurantVM.summaryAvailableRestaurantArr);
    };

    $scope.isCanLoadMore = function () {
        return $scope.Paging.isCanLoadMore();
    };

    $scope.loadMore = function () {
        var moreItems = $scope.Paging.loadMore();
        if(moreItems.length !== 0){
            $scope.restaurantVM.summaryAvailableRestaurantArr = $scope.restaurantVM.summaryAvailableRestaurantArr.concat(moreItems);
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };
    
    $scope.goToRestaurantMenuPage = function(res){
        // Update resId in globalRestaurant with the choosen resId
        GlobalRestaurant.setResId(res.id);
        GlobalRestaurant.setResName(res.name);
        GlobalRestaurant.setSkuHeaderText(res.skuHeaderText);
        // Go to restaurant menu
        $scope.goToPage(page_name.res_menu);
    };
    
    $scope.goToRestaurantShow = function(res, $event){
        // Go to restaurant info
        $scope.stopPropagation($event);
        GlobalRestaurant.setResId(res.id);
        GlobalRestaurant.setResName(res.name);
        GlobalRestaurant.setSkuHeaderText(res.skuHeaderText);
        $scope.goToPage(page_name.res_show);    
    };
    
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });
    
    $scope.init();
});