skipQueueApp.controller('DiscoverResultCtrl', function ($rootScope, $scope, RestaurantService, $ionicScrollDelegate, GlobalRestaurant, Utilities, Paging, dishList) {
     $scope.arrDishesAll=[];
     $scope.isReverse = null;
    $scope.init = function () {
        $scope.showNotice = true;
        $scope.noData = false;
        if (!dishList.length) {
            $scope.noData = true;
            return;
        }
        // Parse model data to view model
        var parseResult = $scope.parseData(RestaurantService.parseDataGetDishByTag, dishList);

        // if error return
        if (!$scope.isParseDataSuccess(parseResult)) {
            return;
        }

        // success case
        $scope.arrDishesAll = parseResult.obj;
        $scope.sortProperty = 'fPrice';
        $scope.sortDish(false);
        
    };
    
    $scope.selectOrderBy = function (orderBy) {
        $scope.sortProperty = orderBy;
        switch (orderBy){
            case 'favCounter':
                $scope.sortDish(true);
                break;
            case 'orderedCounter':
                $scope.sortDish(true);
                break;
            case 'fPrice':
                $scope.sortDish(false);
                break;
        }
        
    };

    $scope.sortDish = function (isReverse) {
        $scope.isReverse = !isReverse;
        $scope.arrDishesAll = angular.copy(Utilities.sort($scope.arrDishesAll, $scope.sortProperty, isReverse));
        $scope.dishesAll =  angular.copy($scope.arrDishesAll);
        $scope.Paging = new Paging($scope.dishesAll);
        $scope.dishes = $scope.Paging.loadMore();
    };

    $scope.isCanLoadMore = function () {
        return $scope.Paging.isCanLoadMore();
    };

    $scope.loadMore = function () {
        //$scope.isLoading = true;
        var moreItems = $scope.Paging.loadMore();
        if (moreItems.length !== 0) {
            $scope.dishes = $scope.dishes.concat(moreItems);
        }
        $rootScope.$broadcast('loading:hide');
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };

    $scope.goToDishDetailPage = function (dish) {
        if(!dish.isActive){
            return;
        }
        var resId = dish.resId;
        var catId = dish.catId;
        var dishId = dish.id;
        // Update resId in globalRestaurant with the choosen resId
        var globalRes = GlobalRestaurant.getAll();
        globalRes.resId = resId;
        globalRes.choosenCat.id = catId;
        GlobalRestaurant.setResData(globalRes);

        $scope.goToPageWithParams(page_name.dish_detail, {dishId: dishId});
    };
    
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });
    
    $scope.init();
    
    $scope.$on('changeLikedItem', function(event, data){
        if(data){
            angular.forEach($scope.arrDishesAll, function(item){
                if(item.id === data.id){
                    item.favCounter = data.favCounter;
                    item.isLiked = data.isLiked;
                }
            });
        }
    });
});