skipQueueApp.controller ('RestaurantMenuCtrl', function($rootScope, $scope, RestaurantService, GlobalRestaurant, GlobalUser, 
                categories, CommonService, UserService, OrderCart, Utilities, $ionicHistory, PromotionSrv,
                $stateParams, $ionicSideMenuDelegate) {
    $scope.blocks = [
        //{icon:"img/test/icon-1.png", caption:"FOR YOU", click:"goToPage('for_you')"},
        {icon:"", caption:"FAVOURITES", click:"goToPage('" + page_name.restaurant_favourites + "')"}//},
        //{icon:"img/test/icon-2.png", caption:"IT'S FRIDAY", click:"goToPage('is_friday')"}        
    ];       
    $scope.init = function(){
        //get icon
        if($rootScope.icon_favourite){
            $scope.blocks[0].icon = $rootScope.icon_favourite;
        }
        if($rootScope.icon_discover){
            $scope.icon_discover = $rootScope.icon_discover;
        }//img/menu/icon-search.png
        if($rootScope.icon_promotion){
            $scope.icon_promotion = $rootScope.icon_promotion;
        }//img/menu/icon-promotion.png
        // get restaurant name in globalrestaurant
        $scope.restaurant_name = GlobalRestaurant.getResName();
        $scope.user_name = '';
        OrderCart.setResId(GlobalRestaurant.getResId());
        OrderCart.setResName(GlobalRestaurant.getResName());
        
        // HocOT - ticket 1171
        // remove the currentSubCat and currentSubSubCat
        OrderCart.clearLastSelection(); // just in case ...

        // if user - user has logged in
        // set user_name
        GlobalUser.getUser().then(function(user){
           if(user){
                $scope.user_name = user.full_name;//"Brandon";//            
                
                // caoth: the service require user logined
                var cart = OrderCart.getCart();
                PromotionSrv.getPromotionList(constant.chain_id, GlobalRestaurant.getResId(),
                        user.user_id, cart.selectedOrderType, cart.dateTime, constant.language_code).then(function (data) {
                    $rootScope.$broadcast('loading:hide');
                    var parseResult = $scope.parseData(PromotionSrv.parseDataListPromo, data);
//                    console.log(parseResult);
                    GlobalRestaurant.setNumberOfPromotions(parseResult.obj.length);
                }, function (error) {
                    $rootScope.$broadcast('loading:hide');
                    $scope.errorHandler(error);
        //            Utilities.showAlertError(constant.language.err_msg.mess_title_error, error.message);
        //            dfd.reject(error);
                });
            } 
        });
        
        // Parse model data to view model
        var parseResult = $scope.parseData(RestaurantService.parseDataMenu, categories);
        // Check parse data result
        // if error
        // return
        if(!$scope.isParseDataSuccess(parseResult)){
            return;
        }
        
        // success case
        $scope.categories = parseResult.obj;
        
        // ToDo caoth: 
        // check whether there is a selected-dish added from dish_detail
        // if yes --> check whether the selected-dish is avaialble for the selected order type
            // if yes --> add the selected-dish into the order cart
            // if no --> delete the selected-dish & alert to user: "The [dish name] is not available for [OrderType]"
        
        $scope.itemInCartCount = OrderCart.getItemCount(); 
        
        CommonService.getChainHomePage(constant.chain_id).then(function(data){
            var temp = $scope.parseData(UserService.parseChainHomeData, {data: data, $scope: $scope});
            //+ If not exist is update infor of user that. Goto Home page.
            if(!$scope.isParseDataSuccess(temp)){
                return;
            }
            $scope.data = temp.obj;
        }, function(error){
            $rootScope.$broadcast('loading:hide');
            $scope.errorHandler(error);
        });
        
        
        
//        if(OrderCart.getCart().selectedOrderType.length == 0){
//            $scope.showNotice();
//        }
        
        if(!isInHistory(page_name.res_menu) && OrderCart.getCart().selectedOrderType.length === 0){
            $scope.showNotice();
        }
        
        // Ticket 1171 - open order cart
        if($stateParams.openOrderCart && $stateParams.openOrderCart === "true"){
            $ionicSideMenuDelegate.toggleRight(true);
        }
    };
    
    $scope.showNotice = function () {
        Utilities.jsShortToast(constant.language.msg_item_availability_may_vary);
//        var buttons = [
//            {
//                text: 'Ok',
//                type: 'button'
//            }
//        ];
//        Utilities.showPopup($scope, constant.language.title_hints, constant.language.msg_item_availability_may_vary, buttons);
    };
    
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });
    
    // TODO
    // Harde code or call API to get blocks?
//    $scope.blocks = [
//        {icon:"ion-ios-person", caption:"FOR YOU", click:"goToPage('for_you')"},
//        {icon:"ion-heart", caption:"FAVOURITES"},//, click:"goToPage('" + page_name.restaurant_favourites + "')"},
//        {icon:"ion-ios-calendar-outline", caption:"IT'S FRIDAY", click:"goToPage('is_friday')"}        
//    ];
    
    
    $scope.goToCatDetailPage = function(category){
        //hack
//        $ionicLoading.show({
//            template: '<ion-spinner icon="dots"></ion-spinner>',
//        });
//        $('.lockModal').show();
        
        var globalResTemp = GlobalRestaurant.getAll();
        globalResTemp.choosenCat = {name: category.name, id: category.id};//{name: 'Burger', id: '10'};
        GlobalRestaurant.setResData(globalResTemp);
        $scope.goToPage(page_name.category_show);
    };
    
    $scope.goToPromotionListPage = function(){
        $scope.checkLogin().then(function(result){
            if(result){
                if (GlobalRestaurant.getNumberOfPromotions() === 0) {
//                    var buttons = [
//                        {
//                            text: 'OK',
//                            type: 'button'
//                        }
//                    ];
//                    Utilities.showPopup($scope, "", constant.language.msg_no_promotion, buttons);

                    Utilities.jsShortToast(constant.language.msg_no_promotion);
                }
                else {
                    $scope.goToPage(page_name.promotion_list);
                }
                
            } else {
                Utilities.showConfirm(constant.language.msg_login_required, constant.language.msg_do_you_want_login, function(res){
                    if(res){
                        Utilities.goBackToLogin(page_name.promotion_list, []);
                    }
                });
            }
        });
    };
    
    $scope.calculateStyle = function() {
        var style={};
//        console.log(GlobalRestaurant.getNumberOfPromotions());
        if (GlobalRestaurant.getNumberOfPromotions() === 0) 
            style.opacity = 0.35;
        return style;
    }
    
    // Ouput: true - in history / false - not in history
    var isInHistory = function(pageName){
        var oldViews = $ionicHistory.viewHistory().views;
        var length = Object.keys(oldViews).length;
        var lastObj = Object.keys(oldViews)[length - 1];
        var isStop = false;
        var result = false;
        angular.forEach(Object.keys(oldViews), function(key){
            if(isStop){
                return;
            }
            
            if(oldViews[key].stateName == pageName && key != lastObj){
                isStop = true;
                result = true;
            }
        });
        
        return result;
    };
    
    $scope.init();
});