skipQueueApp.controller('RestaurantPickupController', function ($rootScope, $scope, GlobalRestaurant, $filter, $ionicScrollDelegate,
        restaurantsOfPickup, DeliveryRestaurantViewModel, RestaurantService, Paging) {
    //$scope.info = "Crust Pizza";
    $scope.restaurant_default = "img/i-crust.png";
    $scope.arrAvailableLenght = -1;
    $scope.pickUpOriginAvailableList = [];
    $scope.pickUpOriginUnAvailableList = [];
    $scope.searchName = '';    

    $scope.init = function () {
//        if (false) { // Call Api
//            $scope.pickupRestaurantVM = parseDataToViewModel(restaurantsOfPickup.data);
//        } else {
//            var restaurantsOfPickup = {
//                data: {}
//            };
//
//            restaurantsOfPickup.data = {
//                availableList: [{
//                        id: "01",
//                        name: 'Crust Pizza, Plaza Singapura',
//                        logo_url: "img/i-res-01.png",
//                        distance: '0.4 km',
//                        lead_time:'45 mins',
//                        opening_time: '09:00-20:00',
//                        additional_info: []
//                    }, {
//                        id: "02",
//                        name: 'Crust Pizza, Holland Village',
//                        logo_url: "img/i-res-02.png",
//                        distance: '58.0 km',
//                        lead_time:'60 mins',
//                        opening_time: '09:00-20:00',
//                        additional_info: []
//                    }],
//                unavailableList: [{
//                        id: "03",
//                        name: 'Crust Pizza, Causeway Point',
//                        logo_url: "img/i-res-03.png",
//                        distance: '58.0 km',
//                        lead_time:'-',
//                        opening_time: '09:00-20:00',
//                        additional_info: []
//                    }, {
//                        id: "04",
//                        name: 'Crust Pizza, Jurong Point',
//                        logo_url: "img/i-res-04.png",
//                        distance: '58.0 km',
//                        lead_time:'-',
//                        opening_time: '09:00-20:00',
//                        additional_info: []
//                    }]
//            };
//
//            var extraData = {
//                name: 'Crust Pizza, Plaza Singapura',
//                id: "01",
//                logo_url: "img/i-res-01.png",
//                distance: '58.0 km',
//                lead_time:'-',
//                opening_time: '09:00-20:00',
//                additional_info: []
//            };
//
//            var extraData2 = {
//                name: 'Crust Pizza, Holland Village',
//                logo_url: "img/i-res-02.png",
//                id: "02",
//                distance: '58.0 km',
//                lead_time:'-',
//                opening_time: '09:00-20:00',
//                additional_info: []
//            };
//
//            for (var i = 0; i < 10; i++) {
//                restaurantsOfPickup.data.availableList.push(extraData);
//                //restaurantsOfPickup.data.availableList.push(extraData2);
//            }   
//            
//            for (var i = 0; i < 10; i++) {
//                restaurantsOfPickup.data.unavailableList.push(extraData2);
//                //restaurantsOfPickup.data.unavailableList.push(extraData2);
//            }  
//            $scope.pickupRestaurantVM = parseDataToViewModel(restaurantsOfPickup.data);
//        }
        $scope.pickupRestaurantVM = parseDataToViewModel(restaurantsOfPickup);
        $scope.originSummaryAvailableRestaurants = angular.copy($scope.pickupRestaurantVM.summaryAvailableRestaurantArr);
    };
    
    var parseDataToViewModel = function (model) {
        var viewModel = RestaurantService.parseDataFindResOfPickup(model);
        $scope.pickUpOriginAvailableList = angular.copy(viewModel.availableList);
        $scope.pickUpOriginUnAvailableList = angular.copy(viewModel.unavailableList);
        var arrSumaryRes = viewModel.availableList.concat(viewModel.unavailableList);
        $scope.arrAvailableLenght = viewModel.availableList.length;
        $scope.Paging = new Paging(arrSumaryRes);
        return new DeliveryRestaurantViewModel($scope.Paging.loadMore(), viewModel.availableList, viewModel.unavailableList);
    };
    var searchRestaurantByName = function (arr, name) {
        //return $filter('filter')(arr, {name: name, cuisineType:name});
        return arr.filter(function (restaurant) {
            return restaurant.name.toLowerCase().indexOf(name.toLowerCase()) >= 0
                    || restaurant.cuisineType.toLowerCase().indexOf(name.toLowerCase()) >= 0;
        });
    };

    $scope.doSearch = function (e) {
        if (e.which === 13 || e.which === 32) {
            if ($scope.searchName || $scope.searchName === '') {
                if ($scope.searchName === '') {
                    $scope.clearSearch();
                } else {
                    var result = searchRestaurantByName(angular.copy($scope.pickUpOriginAvailableList), $scope.searchName);
                    var resultUnavalible = searchRestaurantByName(angular.copy($scope.pickUpOriginUnAvailableList), $scope.searchName);
                    //search on Unavailable Restaurants
                    $scope.arrAvailableLenght = result.length;
                    $scope.pickupRestaurantVM.summaryAvailableRestaurantArr = result.concat(resultUnavalible);
                    $scope.Paging.init($scope.pickupRestaurantVM.summaryAvailableRestaurantArr);
                }
                $ionicScrollDelegate.scrollTop();
            }
            cordova.plugins.Keyboard.close();
        }
    };

    $scope.clearSearch = function () {
        $scope.searchName = '';
        var result = angular.copy($scope.pickUpOriginAvailableList); //$scope.originSummaryAvailableRestaurants);
        //search on Unavailable Restaurants
        var resultUnavalible = angular.copy($scope.pickUpOriginUnAvailableList); //$scope.originUnavailableRestaurants);
        $scope.arrAvailableLenght = result.length;
        $scope.pickupRestaurantVM.summaryAvailableRestaurantArr = result.concat(resultUnavalible);
        
        $scope.Paging.init($scope.pickupRestaurantVM.summaryAvailableRestaurantArr);
    };

    $scope.isCanLoadMore = function () {
        return $scope.Paging.isCanLoadMore();
    };

    $scope.loadMore = function () {
        //$scope.isLoading = true;
        var moreItems = $scope.Paging.loadMore();
        if(moreItems.length !== 0){
            $scope.pickupRestaurantVM.summaryAvailableRestaurantArr = $scope.pickupRestaurantVM.summaryAvailableRestaurantArr.concat(moreItems);
        }
        $scope.$broadcast('scroll.infiniteScrollComplete');
    };
    
    $scope.goToRestaurantMenuPage = function(res){
        // Update resId in globalRestaurant with the choosen resId
        GlobalRestaurant.setResId(res.id);
        GlobalRestaurant.setResName(res.name);
        GlobalRestaurant.setSkuHeaderText(res.skuHeaderText);
        // Go to restaurant menu
        $scope.goToPage(page_name.res_menu);
    };
    
    $scope.goToRestaurantShow = function(res, $event){
        // Go to restaurant info
        $scope.stopPropagation($event);
        GlobalRestaurant.setResId(res.id);
        GlobalRestaurant.setResName(res.name);
        GlobalRestaurant.setSkuHeaderText(res.skuHeaderText);
        $scope.goToPage(page_name.res_show);
        
    };
    
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });
    
    $scope.init();
});