skipQueueApp.controller ('SignUpCtrl', function($rootScope, $scope, $ionicActionSheet, $timeout, 
                        Validation, Utilities, UserService, GlobalUser, $stateParams, GlobalStaff) {
    $scope.isReadOnly_Email = false;
    $scope.agreeFlg= false;
    $scope.recieveFlg= false;
    $scope.dateNow= new Date();   
    //init value
    $scope.init = function(){      
        if($rootScope.profile){
            $scope.profile = $rootScope.profile;
        }
        else{
            $scope.profile = {social_account_id: '', social_type:'', avatar:constant.url_avatar_default_sign_up, 
                            first_name : '', last_name : '', email : '', pass: '', confirmPass: '', mobile_no:'',
                            dateofbirth: '', address: []};
        }
        
        // set params from previous pages (e.g. from fb)
        if($stateParams.email){
            $scope.profile.email = $stateParams.email;
        }
        if($stateParams.phone){
            $scope.profile.mobile_no = $stateParams.phone;
        }
        if($stateParams.social_id){
            if($stateParams.email){
                $scope.profile.email = $stateParams.email;
                $scope.isReadOnly_Email = true;
            }
//            console.log($stateParams);
//            console.log('signup: ' + $stateParams.avatar);
            if($stateParams.avatar){
//                $scope.profile.avatar = $stateParams.avatar;
                
                Utilities.getBase64FromImageUrl($stateParams.avatar, function(base64Img){
                    // Base64DataURL
                    $scope.profile.avatar = base64Img;
                });
            }
            if($stateParams.firstName){
                $scope.profile.first_name = $stateParams.firstName;
            }
            if($stateParams.lastName){
                $scope.profile.last_name = $stateParams.lastName;
            }
            $scope.profile.social_account_id = $stateParams.social_id;
            $scope.profile.social_type = constant.social_type_fb;
        }
        
        $scope.agreeFlg = constant.is_skipque ? false : true;
        
    };  
    
    //sign up
    $scope.signup = function() {
        //Validation fields
        if(!validation()){
            return ;
        }
        if (constant.is_skipque) {
            UserService.signUp(constant.chain_id, $scope.profile.social_account_id, $scope.profile.social_type, 
                        $scope.profile.avatar, $scope.profile.pass, $scope.profile.first_name, $scope.profile.last_name,
                        $scope.profile.email, Utilities.formatDateTime(constant.formatDateTime,$scope.profile.dateofbirth), 
                        $scope.recieveFlg, $scope.profile.mobile_no, $scope.profile.address, $rootScope.device_token).then(function(data){
                    // Parse data
                    var userParse = $scope.parseData(UserService.parseLoginUserData, data);
                    //+ If not exist is update infor of user that. Goto Home page.
                    if(!$scope.isParseDataSuccess(userParse)){
                        return;
                    }
                    delete $rootScope.profile;
                    // Save user info.
                    GlobalUser.init(userParse.obj);
                    //Goto HOME page.
                    $scope.goToPage(page_name.index);
                }, function(error){
                    $rootScope.$broadcast('loading:hide');
                    $scope.errorHandler(error);
            });
        }
        else {
            GlobalStaff.getStaff().then(function (data) {
                if (data && data.staff_id) {
                    // caoth #1115
                    UserService.signUpNotRequireEmail(constant.chain_id, $scope.profile.social_account_id, $scope.profile.social_type, 
                            $scope.profile.avatar, $scope.profile.pass, $scope.profile.first_name, $scope.profile.last_name,
                            $scope.profile.email, Utilities.formatDateTime(constant.formatDateTime,$scope.profile.dateofbirth), 
                            $scope.recieveFlg, $scope.profile.mobile_no, $scope.profile.address, $rootScope.device_token, data.staff_id).then(function(data){
                            // Parse data
                            var userParse = $scope.parseData(UserService.parseLoginUserData, data);
                            //+ If not exist is update infor of user that. Goto Home page.
                            if(!$scope.isParseDataSuccess(userParse)){
                                return;
                            }
                            delete $rootScope.profile;
                            // Save user info.
                            GlobalUser.init(userParse.obj);
                            //Goto HOME page.
                            $scope.goToPage(page_name.order_type);
                        }, function(error){
                            $rootScope.$broadcast('loading:hide');
                            $scope.errorHandler(error);
                    });
                }
                else{
                    $scope.goToPage(page_name.login);
                }
            });
        }
        
        
        
    };
    
    // action sheet
    $scope.show = function() {
        // Show the action sheet
        var hideSheet = $ionicActionSheet.show({
         buttons: [
           { text: '<b>Take a picture</b>' },
           { text: '<b>Choose from Galary</b>' }
         ],
         titleText: 'Add your avatar',
         cancelText: '<b>Cancel</b>',
         cancel: function() {
              // add cancel code..
            },
         buttonClicked: function(index) {
            if (index === 0){
                $scope.takePicture($scope.loadAvatarURL).then(function(data){
                    $scope.profile.avatar = data;
                    return true;
                }, function(error){
                    console.log('11'); // caoth: log 11 ?
                });
            }
            if (index === 1){
                $scope.choosePictures($scope.loadAvatarURL).then(function(data){
                    $scope.profile.avatar = data;
                    return true;
                }, function(error){
                    console.log('11');// caoth: log 11 ?
                });
            }            
            
         }
       });

       // hide the sheet after two seconds
        $timeout(function() {
        hideSheet();
      }, 5000);
    };
    
    //Change AgreeFlg value
    $scope.changeAgreeFlg = function(){
       if($scope.agreeFlg){
           $scope.agreeFlg = false;
        }
        else{
            $scope.agreeFlg = true;
        }
    }; 
    
    //Change ReciveFlg value
    $scope.changeRecieveFlg = function(){
       if($scope.recieveFlg){
           $scope.recieveFlg = false;
        }
        else{
            $scope.recieveFlg = true;
        }
    };  
    
    $scope.goToEditPage = function (arr_index, $event) {
        $scope.stopPropagation($event);
        $rootScope.profile = $scope.profile;
        $scope.goToPage(page_name.add_address);
    };
            
    $scope.validationDateBirth = function(){
//        $scope.profile.dateofbirth =  angular.copy(Utilities.formatDateTime(constant.formatDateTime,$scope.profile.dateofbirth));
        if(!UserService.validationDateBirth($scope.profile.dateofbirth))
            return;
    };
    
    $scope.clickTermsAndConditions = function(){
        $rootScope.profile = $scope.profile;
        $scope.goToPage(page_name.terms);
    };
    
    function validation(){
        var arrError = [];
        
        if(!$scope.profile.first_name || !$scope.profile.mobile_no){
            $scope.errorHandler({errorCode: error_code.validation, message: constant.language.mess_content_check_info_highlight_in_red});
            return false;
        }
        if(constant.is_skipque) {
            if(!$scope.profile.pass || !$scope.profile.confirmPass || !$scope.profile.dateofbirth || !$scope.profile.last_name || !$scope.profile.email){
                $scope.errorHandler({errorCode: error_code.validation, message: constant.language.mess_content_check_info_highlight_in_red});
                return false;
            }
            
            if($scope.profile.dateofbirth){
                if(!UserService.validationDateBirth($scope.profile.dateofbirth))
                    return false;
            }
            
            var val_pass = Validation.validationPassword($scope.profile.pass);//Pass text length at least 8 characters. 
            if(!val_pass.result)
                arrError.push(val_pass.message);
            
            var val_email = Validation.validationEmail($scope.profile.email);        
            if(!val_email.result)
                arrError.push(val_email.message);
        }
        
        if($scope.profile.mobile_no){
            var val_phone = Validation.validationPhone($scope.profile.mobile_no);
            if(!val_phone.result){
                arrError.push(val_phone.message);
            }
        }
        
        // Radio "I arggee and accept" is required check. Default load page is uncheck.
        if(!$scope.agreeFlg){
            arrError.push(constant.language.mess_check_agree_and_accept);
        }
        
        //check comfirm pass with password
        if($scope.profile.confirmPass !== $scope.profile.pass){
            arrError.push(constant.language.mess_pass_do_not_match);
        }
        
        //check image 
        if($scope.profile.avatar.indexOf(constant.data_base64) === -1){//not exist == -1
            $scope.profile.avatar = "";
        }
        else{
            $scope.profile.avatar = $scope.profile.avatar.replace(constant.data_base64,"");
        }
        
        if(arrError.length>0){
            var errObj={errorCode: error_code.validation, message: arrError.join(' <br /> ')};
            $scope.errorHandler(errObj);
            return false;
        }
        return true;
    }
    
    $scope.$on("$ionicView.beforeLeave", function(){
        $rootScope.$broadcast('loading:show');
    });

    $scope.$on("$ionicView.enter", function(){
        $rootScope.$broadcast('loading:hide');
    });
    
    $scope.init();
});