skipQueueApp.factory('Bill', function (Utilities) {
    var Bill = function () {
    };

    Bill.prototype.init = function (data) {
        this.dishes = data.dishes;
        this.subTotal = data.subTotal;
        this.currency = data.currency;
        this.discountChargeTax = data.discountChargeTax;
        this.priceIncludeGST = data.priceIncludeGST;
        this.grandTotal = data.grandTotal;
    };

    /**
     * Input: a order got from server
     * Output: view model data
     * */
    Bill.prototype.parseData = function (resOrder) {
        var data = parseData(resOrder);
        this.init(data);
    };

    var parseData = function (resOrder) {
        var result = {
            subTotal: resOrder.sub_total,
            grandTotal: resOrder.grand_total,
            currency: resOrder.currency,
            discountChargeTax: [],
            priceIncludeGST: resOrder.price_include_gst,
            dishes: []
        };

        angular.forEach(resOrder.discount_charge_tax, function (DCTObj) {
            var dtc = {
                name: DCTObj.name,
                amount: DCTObj.value,
                value: DCTObj.value_unit
            };

            result.discountChargeTax.push(dtc);
        });

        angular.forEach(resOrder.dishes, function (dish) {
            var temp = {
                id: dish.dish_id,
                name: dish.dish_name,
                quantity: dish.quantity,
                amount: dish.amount,
                sku_name: dish.sku_name,
                sku_price: dish.sku_price,
                sku_price_value: dish.sku_price_value,
                specialInstruction: dish.special_instruction,
                customizations: []
            };

            angular.forEach(dish.customizations, function (opt) {
                var optTemp = {
                    id: opt.cust_opt_id,
                    name: opt.cust_opt_name,
                    price: opt.cust_opt_price,
                    price_value: opt.cust_opt_price_value,
                    quantity: opt.cust_opt_quantity,
                    amount: opt.cust_opt_amount
                };

                temp.customizations.push(optTemp);
            });

            result.dishes.push(temp);
        });

        return result;
    };

    return Bill;
});