skipQueueApp.factory('Order', function(Bill, Utilities){
    var Order = function () {};
    
    Order.prototype.init = function (data) {
        this.id = data.id;
        this.number = data.number;
        this.status = data.status;
        this.deliveryTime = data.deliveryTime;
        this.clientPageType = data.clientPageType;
        this.datetime = data.datetime;
        this.orderType = data.orderType;
        this.orderTypeId = data.orderTypeId;
        this.location = data.location;
        this.bill = data.bill;
        this.orderLogs = data.orderLogs;
    };

    /**
     * Input: a order got from server
     * Output: view model data
     * */
    Order.prototype.parseData = function (resOrder) {
        var data = parseData(resOrder);
        this.init(data);
    };


    var parseData = function (resOrder) {
        var result = {
            id: resOrder.order_id,
            number: resOrder.order_no,
            status: resOrder.order_status,
            deliveryTime: Utilities.getDateTimeFromString(resOrder.delivery_time),
            clientPageType: resOrder.client_page_type,
            datetime: (typeof resOrder.created_date != 'undefined') ? Utilities.getDateTimeFromString(resOrder.created_date) : resOrder.delivery_time,//resOrder.date_time,
            orderType: resOrder.order_type,
            orderTypeId: resOrder.order_type_id,
            location: resOrder.location,
            orderLogs: [],
            bill: new Bill()
        };
        
        if(resOrder.order_logs){
            angular.forEach(resOrder.order_logs, function(log){
                var temp = {
                    time: parseStringToTime(log.time),
                    content: log.content
                };

                result.orderLogs.push(temp);
            });
        }

        return result;
    };
    
    var parseStringToTime = function(time){
        var date = new Date();
        var arr = time.split(':');
        date.setHours(arr[0]);
        date.setMinutes(arr[1]);
        return date;
    };
    
    return Order;
});