skipQueueApp.factory('Promotion', function () {

    var Promotion = function () {};

    Promotion.prototype.init = function (data) {
        this.id = data.id;
        this.name = data.name;
        this.code = data.code;
        this.image = data.image;
        this.description = data.description;
        this.discountType = data.discountType;
        this.discountValue = data.discountValue;
        this.applyAllCategory = data.applyAllCategory;
        this.freeItem = data.freeItem;
        this.applyDishes = data.applyDishes;
        this.applyCategories = data.applyCategories;
        //this.offeredItems = data.offeredItems;
    };

    /**
     * Input: a promotion got from server
     * Output: view model data
     * */
    Promotion.prototype.parseData = function (resPromo) {
        var data = parseData(resPromo);
        this.init(data);
    };


    var parseData = function (resPromo) {
        var result = {
            id: resPromo.promo_id,
            code: resPromo.promo_code,
            image: resPromo.promo_image,
            name: resPromo.promo_name,
            description: resPromo.promo_description,
            discountType: resPromo.discount_type,
            discountValue: resPromo.discount_value,
            applyAllCategory: resPromo.apply_all_category,
            freeItem: {},
            applyDishes: [],
            applyCategories: [],
            offeredItems: []
        };
        
        if(resPromo.free_item){
            result.freeItem = {
                dishId: resPromo.free_item.dish_id,
                skuId: resPromo.free_item.sku_id,
                name: resPromo.free_item.dish_name
            };
        }

        if (resPromo.offered_items && resPromo.offered_items.length > 0) {
            angular.forEach(resPromo.offered_items, function (item) {
                var temp = {
                    itemId: item.dish_id,
                    itemName: item.dish_name,
                    itemPrice: item.price,
                    itemOrgPrice: item.org_price
                };

                result.offeredItems.push(temp);
            });
        }
        
        if(resPromo.apply_dishes && resPromo.apply_dishes.length > 0){
            angular.forEach(resPromo.apply_dishes, function (item) {
                var temp = {
                    id: item.dish_id,
                    skuId: item.sku_id
                };

                result.applyDishes.push(temp);
            });
        }
        
        if(resPromo.apply_categories && resPromo.apply_categories.length > 0){
            angular.forEach(resPromo.apply_categories, function (item) {
                var temp = {
                    id: item.category_id,
                    subCatId: item.sub_category_id
                };

                result.applyCategories.push(temp);
            });
        }

        return result;
    };

    Promotion.prototype.setName = function(name){
        this.name = name;
    };
    
    Promotion.prototype.setDescription = function(des){
        this.description = des;
    };

    return Promotion;
});