skipQueueApp.service('CommonService', function ($rootScope, ConnectionService, $q) {
    var _countries = null;
    this.getChainHomePage = function (chainId) {
        var dfd = $q.defer();
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId}];
        // Call API "get_chain_home_page_data"
        ConnectionService.get(api_url.get_chain_home_page_data, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };
    
    this.getCountry = function () {
        var dfd = $q.defer();
        if(!_countries){
            //call api get country
            var rawParams = [];
            ConnectionService.get(api_url.get_countries, rawParams).then(function(data){
                    _countries = data.countries;
                    dfd.resolve(_countries);  
                }, function(error){
                    $rootScope.$broadcast('loading:hide');
                    console.log(error);
                    dfd.reject(error);
            });
        }
        else{
            dfd.resolve(_countries);  
        } 
        return dfd.promise;
    };
    
    this.getState = function (valCountry) {
        var dfd = $q.defer();
        //call api get city
        var rawParams = [{prm_name: params_name.country, prm_value: valCountry},
                        {prm_name: params_name.state, prm_value: "states" }];
        ConnectionService.get(api_url.get_state, rawParams).then(function(data){
                dfd.resolve(data.states);  
            }, function(error){
                $rootScope.$broadcast('loading:hide');
                console.log(error);
                dfd.reject(error);
        });
        return dfd.promise;
    };
    
    this.getCity = function (valState) {
        var dfd = $q.defer();
        //call api get city
        var rawParams = [{prm_name: params_name.state, prm_value: valState },
                        {prm_name: params_name.city, prm_value: "cities" }];
        ConnectionService.get(api_url.get_city, rawParams).then(function(data){
                dfd.resolve(data.cities);    
            }, function(error){
                $rootScope.$broadcast('loading:hide');
                console.log(error);
                dfd.reject(error);
        });
        return dfd.promise;
    };
    
    this.getCommonImages = function(chainId){
        var dfd = $q.defer();
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId}];
        
        ConnectionService.get(api_url.get_common_images_data, rawParams).then(function(data){
                dfd.resolve(data);    
            }, function(error){
                $rootScope.$broadcast('loading:hide');
                console.log(error);
                dfd.reject(error);
        });
        return dfd.promise;  
    };
    
    this.parseCommonImagesData = function(response) {
        var result = {
            splash_img: response.splash,
            help_pages: response.help_pages,
            chain_logo: response.login_page_logo,
            icon_discover: response.icon_discover,
            icon_promotion: response.icon_promotion,
            icon_favourite: response.icon_favorite
        };

        return result;
    };
    
    this.parseAboutUs = function(data){
        return {title: data.title, content: data.content, img_url: data.img_url};
    };
    
    this.sendEmailReceipt = function(userId, orderId, orderTypeId){
        var dfd = $q.defer();
        var rawParams = [{
            prm_name: params_name.chain_id,
            prm_value: constant.chain_id
        }, {
            prm_name: params_name.user_id,
            prm_value: userId
        }, {
            prm_name: params_name.order_id,
            prm_value: orderId
        }, {
            prm_name: params_name.order_type,
            prm_value: orderTypeId
        }];
    
        ConnectionService.post(api_url.send_email_receipt, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            dfd.reject(error);
        });
        
        return dfd.promise;
    };
    
    // About
    this.getAboutUS = function (chainId) {
        var dfd = $q.defer();
        //array paramater
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId}];
        // Call API "get_faqs"
        ConnectionService.get(api_url.get_about_us, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };
});