/*
 *  return connection error (connection timeout, can't conect to server)
 *  return data isn't JSON format
 */
skipQueueApp.service('ConnectionService', function ($rootScope, $q, ConnectionParseData, Connection, Utilities, ConnectivityMonitor) {
//    this.get = function (url, data) {
//        // create derfer
//        var dfd = $q.defer();
//
//        if (!checkData(data)) {
//            // return data params error
//            errorHandler(null, dfd);
//        }
//        
//        // prepare send data
//        var sendData = Utilities.prepareParams(data);
//        
//        // prepare called url
//        var resultUrl = Utilities.prepareUrl(url, data);
//
//        // call Angular JS connection lib to call restful service
//        Connection.get(resultUrl, sendData).then(function (res) {
//            // if success
//            successHandler(res, dfd);
//        }, function (error) {
//            // if error
//            $rootScope.$broadcast('loading:hide');
//            errorHandler(error, dfd);
//        });
//
//        return dfd.promise;
//    };

    var newGet = this.get = function (url, data, retryTime, dfd) {
        if (typeof retryTime === 'undefined') { retryTime = 0; }                
        if (typeof dfd === 'undefined') { dfd = $q.defer(); }
        // create derfer
//        var dfd = $q.defer();

        var isOnline = ConnectivityMonitor.isOnline();
        
        if (!isOnline) {                        
            $rootScope.$broadcast('loading:hide');
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.no_internet);
            
            return;
        }

        if (!checkData(data)) {
            // return data params error
            errorHandler(null, dfd);
        }
        
        // prepare send data
        var sendData = Utilities.prepareParams(data);
        
        // prepare called url
        var resultUrl = Utilities.prepareUrl(url, data);

        // call Angular JS connection lib to call restful service
        Connection.get(resultUrl, sendData).then(function (res) {
            // if success
            successHandler(res, dfd);
        }, function (error) {
            if(retryTime < constant.NUMBER_OF_RETRY) {     
                console.log('retry:' + retryTime); 
                newGet(url, data, ++retryTime, dfd);
            }
            else {                                
                console.log('error:' + retryTime); 
                errorHandler(error, dfd);
            }
        });

        return dfd.promise;
    };
    
    var getWithRetry = this.getWithRetry = function (url, data, retryTime, dfd) {        
        if (typeof retryTime === 'undefined') { retryTime = 0; }                
        if (typeof dfd === 'undefined') { dfd = $q.defer(); }
        // create derfer
//        var dfd = $q.defer();

        var isOnline = ConnectivityMonitor.isOnline();

        if (!isOnline) {            
            $rootScope.$broadcast('loading:hide');
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.no_internet);
            
            return;
        }

        if (!checkData(data)) {
            // return data params error
            errorHandler(null, dfd);
        }
        
        // prepare send data
        var sendData = Utilities.prepareParams(data);
        
        // prepare called url
        var resultUrl = Utilities.prepareUrl(url, data);

        // call Angular JS connection lib to call restful service
        Connection.get(resultUrl, sendData).then(function (res) {
            // if success
            successHandler(res, dfd);
        }, function (error) {
            // if error
//            $rootScope.$broadcast('loading:hide');            
//            errorHandler(error, dfd);
            
            console.log(error);
//            console.log('retryTime:' + retryTime); 

            if(retryTime < constant.NUMBER_OF_RETRY) {     
                console.log('retry:' + retryTime); 
                getWithRetry(url, data, ++retryTime, dfd);
            }
            else {                                
                console.log('error:' + retryTime); 
                errorHandler(error, dfd);
//                $rootScope.$broadcast('loading:hide');
            }
            
        });

        return dfd.promise;
    };
    
//    this.postWithParams = function (url, params, data) {
//        var dfd = $q.defer();
//
//        if (!checkData(data)) {
//            // return data params error
//            errorHandler(null, dfd);
//        }
//        
//        // prepare called url
//        var resultUrl = Utilities.prepareUrl(url, params);
//        
//        var sendParams = Utilities.prepareParams(params);
//        
//        // prepare send data
//        var sendData = Utilities.prepareParams(data);
//
//        Connection.postWithParams(resultUrl, sendParams, sendData).then(function (res) {
//            // if success
//            successHandler(res, dfd);
//        }, function (error) {
//            // if error
//            $rootScope.$broadcast('loading:hide');
//            errorHandler(error, dfd);
//        });
//
//        return dfd.promise;
//    };

    var newPostWithParam = this.postWithParams = function (url, params, data, retryTime, dfd) {
        if (typeof retryTime === 'undefined') { retryTime = 0; }                
        if (typeof dfd === 'undefined') { dfd = $q.defer(); }

        var isOnline = ConnectivityMonitor.isOnline();

        if (!isOnline) {            
            $rootScope.$broadcast('loading:hide');
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.no_internet);
            
            return;
        }

        if (!checkData(data)) {
            // return data params error
            errorHandler(null, dfd);
        }
        
        // prepare called url
        var resultUrl = Utilities.prepareUrl(url, params);
        
        var sendParams = Utilities.prepareParams(params);
        
        // prepare send data
        var sendData = Utilities.prepareParams(data);

        Connection.postWithParams(resultUrl, sendParams, sendData).then(function (res) {
            // if success
            successHandler(res, dfd);
        }, function (error) {
            if(retryTime < constant.NUMBER_OF_RETRY) {     
                console.log('retry:' + retryTime); 
                newPostWithParam(url, params, data, ++retryTime, dfd);
            }
            else {                                
                console.log('error:' + retryTime); 
                errorHandler(error, dfd);
            }
        });

        return dfd.promise;
    };

//    this.post = function (url, data) {
//        var dfd = $q.defer();
//
//        if (!checkData(data)) {
//            // return data params error
//            errorHandler(null, dfd);
//        }
//        
//        // prepare send data
//        var sendData = Utilities.prepareParams(data);
//
//        Connection.post(url, sendData).then(function (res) {
//            // if success
//            successHandler(res, dfd);
//        }, function (error) {
//            // if error
//            $rootScope.$broadcast('loading:hide');
//            errorHandler(error, dfd);
//        });
//
//        return dfd.promise;
//    };

    var newPost = this.post = function (url, data, retryTime, dfd) {
        if (typeof retryTime === 'undefined') { retryTime = 0; }                
        if (typeof dfd === 'undefined') { dfd = $q.defer(); }

        var isOnline = ConnectivityMonitor.isOnline();

        if (!isOnline) {            
            $rootScope.$broadcast('loading:hide');
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.no_internet);
            
            return;
        }
        
        if (!checkData(data)) {
            // return data params error
            errorHandler(null, dfd);
        }
        
        // prepare send data
        var sendData = Utilities.prepareParams(data);

        Connection.post(url, sendData).then(function (res) {
            // if success
            successHandler(res, dfd);
        }, function (error) {
            if(retryTime < constant.NUMBER_OF_RETRY) {     
                console.log('retry:' + retryTime); 
                newPost(url, data, ++retryTime, dfd);
            }
            else {                                
                console.log('error:' + retryTime); 
                errorHandler(error, dfd);
            }
        });

        return dfd.promise;
    };

//    this.put = function (url, data) {
//        var dfd = $q.defer();
//
//        if (!checkData(data)) {
//            // return data params error
//            errorHandler(null, dfd);
//        }
//
//        // prepare send data
//        var sendData = Utilities.prepareParams(data);
//        
//        Connection.put(url, sendData).then(function (res) {
//            // if success
//            successHandler(res, dfd);
//        }, function (error) {
//            $rootScope.$broadcast('loading:hide');
//            // if error
//            errorHandler(error, dfd);
//        });
//
//        return dfd.promise;
//    };

    var newPut = this.put = function (url, data, retryTime, dfd) {
        if (typeof retryTime === 'undefined') { retryTime = 0; }                
        if (typeof dfd === 'undefined') { dfd = $q.defer(); }
        
        var isOnline = ConnectivityMonitor.isOnline();

        if (!isOnline) {
            $rootScope.$broadcast('loading:hide');
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.no_internet);            
            
            return;
        }

        if (!checkData(data)) {
            // return data params error
            errorHandler(null, dfd);
        }

        // prepare send data
        var sendData = Utilities.prepareParams(data);
        
        Connection.put(url, sendData).then(function (res) {
            // if success
            successHandler(res, dfd);
        }, function (error) {
            if(retryTime < constant.NUMBER_OF_RETRY) {     
                console.log('retry:' + retryTime); 
                newPut(url, data, ++retryTime, dfd);
            }
            else {                                
                console.log('error:' + retryTime); 
                errorHandler(error, dfd);
            }
        });

        return dfd.promise;
    };

//    this.delete = function (url, data) {
//        var dfd = $q.defer();
//
//        if (!checkData(data)) {
//            // return data params error
//            errorHandler(null, dfd);
//        }
//        
//        // parseUrl
//        //var resultUrl = parseUrl(url, data);
//
//        Connection.delete(url, data).then(function (res) {
//            // if success
//            successHandler(res, dfd);
//        }, function (error) {
//            $rootScope.$broadcast('loading:hide');
//            // if error
//            errorHandler(error, dfd);
//        });
//
//        return dfd.promise;
//    };

    var newDelete = this.delete = function (url, data, retryTime, dfd) {
        if (typeof retryTime === 'undefined') { retryTime = 0; }                
        if (typeof dfd === 'undefined') { dfd = $q.defer(); }
        
        var isOnline = ConnectivityMonitor.isOnline();

        if (!isOnline) {
            $rootScope.$broadcast('loading:hide');
            Utilities.showAlertError(constant.language.err_msg.mess_title_error, constant.language.err_msg.no_internet);
            
            return;
        }

        if (!checkData(data)) {
            // return data params error
            errorHandler(null, dfd);
        }
        
        // parseUrl
        //var resultUrl = parseUrl(url, data);

        Connection.delete(url, data).then(function (res) {
            // if success
            successHandler(res, dfd);
        }, function (error) {
            if(retryTime < constant.NUMBER_OF_RETRY) {     
                console.log('retry:' + retryTime); 
                newDelete(url, data, ++retryTime, dfd);
            }
            else {                                
                console.log('error:' + retryTime); 
                errorHandler(error, dfd);
            }
        });

        return dfd.promise;
    };

    function successHandler(res, dfd) {
//        console.log('success' + res);
        // parse data to check result
        ConnectionParseData.parseData(res).then(function (data) {
            // if true
            // return data
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            // if false
            // return error code
            console.log(error);
            dfd.reject(error);
        });
    }

    function errorHandler(error, dfd) {
        if (error) {
            // return error with error code connection and error message connection created in error file
            error = {
                errorCode: error_code.connection,
                message: error_message.connection
            };
        } else {
            // return error with error code params and error message params created in error file
            error = {
                errorCode: error_code.wrong_params,
                message: error_message.wrong_params
            };
        }

        console.log(error);
        // TODO Ghi connection error log
        dfd.reject(error);
    }
    
    function checkData(data) {
        // if data
        // if data == {}, call API without params
        // if data != {}, call API with params
        if (data) {
            return true;
        } else {
            // if data is null or undefine, return error.
            return false;
        }
    }
});