skipQueueApp.service('CrustPizzarBillingSrv', function (Utilities) {
    this.getTotalPrice = function (dish) {
        var totalPrice = 0;
        // get basePrice
        var basePrice = this.getBasePrice(dish);

        totalPrice += basePrice * dish.quantity;
        return totalPrice;
    };

    this.getBasePrice = function(dish) {
        var skuPrice = parseFloat(dish.selectedSku.price);

        // get cusomizations price
        var cusPrice = getCustomizationPrice(dish.customizations);

        var basePrice = skuPrice + cusPrice;
        return basePrice;
    };

    function getCustomizationPrice(cusList) {
        var totalCusPrice = 0;
        angular.forEach(cusList, function (cus) {
            var cusPrice = 0;
            var paidAfterQuantity = 0;
            angular.forEach(cus.options, function (opt) {
                var optTotalPrice = opt.quantity * parseFloat(opt.price);
                cusPrice += optTotalPrice;
                
                if(cus.paidAfter > 0 && parseFloat(opt.price) === 0){
                    paidAfterQuantity += opt.quantity;
                }
            });

            if (paidAfterQuantity > cus.paidAfter && cus.paidAfter > 0) {
                cusPrice += (paidAfterQuantity - cus.paidAfter) * parseFloat(cus.paidAfterValue);
            }

            totalCusPrice += cusPrice;
        });
        return totalCusPrice;
    }

    this.getCustomizationName = function(cusList,currency_type) {
        angular.forEach(cusList, function (cus) {
            var name = [];
            var paidAfterQuantity = 0;
            var paidAfter='';
            angular.forEach(cus.options, function (opt) {
                if(opt.quantity > 0){
//                    name.push(opt.name + ' (' + (opt.price > 0 ? (currency_type + opt.price) : 'FREE') +') x ' + opt.quantity);
                    name.push(opt.name + (opt.price > 0 ? (' (' + currency_type + opt.price + ')') : '') +' x ' + opt.quantity);                  
                    if(cus.paidAfter > 0 && parseFloat(opt.price) === 0){
                        paidAfterQuantity += opt.quantity;
                    }
                }
            });

            // if paidAfterQuantity greater than or equal to customization paid after then we update the price
            if (paidAfterQuantity >= cus.paidAfter && cus.paidAfter > 0) {
                var paidAfterPrice = (paidAfterQuantity - cus.paidAfter) * parseFloat(cus.paidAfterValue);
                if(paidAfterPrice > 0){
                    paidAfter = ' - ' + constant.language.lbl_paid_after + ' ('+ currency_type + paidAfterPrice.toFixed(constant.number_after_comma) + ')';
                    //show message
//                    Utilities.showShortAlertError('', constant.language.msg_additional + currency_type + paidAfterPrice.toFixed(constant.number_after_comma) + constant.language.msg_charge_for_selection);
//                    if(cus.paidAfterPrice < paidAfterPrice){
//                        Utilities.jsShortToast(constant.language.msg_additional + currency_type + paidAfterPrice.toFixed(constant.number_after_comma) + constant.language.msg_charge_for_selection);
//                    }
                    // caoth 1059 no. 4
                    Utilities.jsShortToast(constant.language.msg_additional + currency_type + paidAfterPrice.toFixed(constant.number_after_comma) + constant.language.msg_charge_for_selection);
                }
                cus.paidAfterPrice = paidAfterPrice;
            }
            
            if(name.length === 0)
                cus.selected_name = cus.name; 
            else
                cus.selected_name = cus.name + ": " + (name.join(", ") + paidAfter);
        });
        
        return cusList;
    };

});