skipQueueApp.service('LocalDB', function ($q) {
    var _db;

    this.init = function () {
        _db = new PouchDB(constant.local_db_name);
//        _db.get('user').then(function (doc) {
//            console.log('get result: ' + doc);
//            return _db.remove(doc);
//        }).then(function (result) {
//            // handle result
//            console.log('remove result: ' + result);
//        }).catch(function (err) {
//            console.log(err);
//        });
    };

    // create data with data _id in local db
    this.put = function (data) {
        var dfd = $q.defer();
        _db.put(data).then(function (res) {
            successHandler(res, dfd);
            ;
        }).catch(function (error) {
            errorHandler(error, dfd);
        });

        return dfd.promise;
    };

    // create data auto generate _id in local db
    this.post = function (data) {
        var dfd = $q.defer();
        _db.post(data).then(function (res) {
            successHandler(res, dfd);
        }).catch(function (error) {
            errorHandler(error, dfd);
        });

        return dfd.promise;
    };

    // get data from local db
    this.get = function (id) {
        var dfd = $q.defer();
        _db.get(id).then(function (res) {
            successHandler(res, dfd);
        }).catch(function (error) {
            errorHandler(error, dfd);
        });

        return dfd.promise;
    };

    this.removeById = function (id, rev) {
        var dfd = $q.defer();
        _db.remove(id, rev).then(function (res) {
            successHandler(res, dfd);
        }).catch(function (error) {
            errorHandler(error, dfd);
        });
        return dfd.promise;
    };

    function successHandler(response, dfd) {
        dfd.resolve(response);
    }
    ;

    function errorHandler(error, dfd) {
        dfd.reject(error);
    }
});