skipQueueApp.service('OrderTypeService', function (ConnectionService, Utilities, OrderCart, $rootScope, RestaurantService) {
    this.parseOrderTypesFromOrderTypeInRes = function (arrOrderTypes) {
        var menu =[];
        angular.forEach(arrOrderTypes, function (ordertype) {
            //for order_types_key[] 
            var objOrderType = $.grep(constCommonObj.order_types_key, function(e){ 
                if(e.id === ordertype){
                    return e;
                }
            });
            var grpName = objOrderType[0].grpName;
            var itm = $.grep(constCommonObj.arr_order_type_default, function(e){ return e.id === grpName; });
            if(itm && itm.length>0 && menu.indexOf(itm[0]) === -1 ){
                menu.push(itm[0]);
            }
        });
        return menu;
    };
    
    this.parsePickupChildFromOrderTypeInRes = function (arrOrderTypes) {
        var orderTypeChild = {isNow:false, isLater:false};
        angular.forEach(arrOrderTypes, function (child) {
            if(child === constant.order_type_child_pickup_now ){
                orderTypeChild.isNow = true;
            }
            if(child === constant.order_type_child_pickup_later ){
                orderTypeChild.isLater = true;
            }
        });
        return orderTypeChild;
    };
    
    function getCheckSupportedOrderTypeParams (resId, orderTypeIds, dishId){
        return [
            {
                prm_name: params_name.chain_id,
                prm_value: constant.chain_id
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: resId
            }, {
                prm_name: params_name.ordertype_id,
                prm_value: orderTypeIds
            }, {
                prm_name: params_name.dish_id,
                prm_value: dishId
            }];
    }
    
    this.checkSupportedOrderType = function(orderTypeIds, dateStr, timeStr, callBack){
        var cart = OrderCart.getCart();
//        if(!cart || cart.dishes == {} || OrderCart.getItemCount() == 0){
//            if(callBack){
//                callBack();
//            }
//            return;
//        }
        if(!cart.tempItem){
            if(callBack){
                callBack();
            }
            return;
        }
        
        var guid = cart.tempItem.guid; //Object.keys(cart.dishes)[0]; // guid of item will be check on server
        var dish = cart.tempItem; //OrderCart.getDish(guid); Item will be check on server
        var rawParams = getCheckSupportedOrderTypeParams(cart.resId, orderTypeIds, dish.id);
        
        $rootScope.$broadcast('loading:show');
        
        //HocOT add logic to check
        var dateTime = null;
        if(dateStr != null && timeStr != null){
            if(orderTypeIds == constant.order_type_child_pickup_later || orderTypeIds == constant.order_type_child_delivery_later){
                dateTime = Utilities.formatDateTime(constant.formatDateTime, new Date(dateStr + ' ' + timeStr));
            }
        }
        
        //HocOT: TODO - need to check the correct coding style for the logic below
        RestaurantService.checkRestaurantAvailability(constant.chain_id, cart.resId, orderTypeIds, dateTime, function() {
            
            if ($rootScope.hackPage) {
                if(callBack){
                    callBack();
                }
                return;
            }            
            ConnectionService.post(api_url.validate_order_type, rawParams).then(function (data) {
                $rootScope.$broadcast('loading:hide');
                if(!data){
                    //OrderCart.removeFromCart(guid);
                    Utilities.showAlertError(constant.language.err_msg.ordertype_error, error_message.order_type);
                    return;
                }
    //            if(dish.recommendation){
    //                checkSupportedOrderTypeForRecommendation(cart.resId, orderTypeIds, dish, callBack);
    //                return;
    //            }

                if(!orderTypeIds.length){
                    OrderCart.updateItemInCart(dish, guid);
    //                OrderCart.clearTempItem(); caoth: keep the temp item (i.e. the latest item) to move to recommendation page
                }

                if(callBack){
                    callBack();
                }
            }, function (error) {
                $rootScope.$broadcast('loading:hide');
                console.log(error);
            });
        });
    };
    
    checkSupportedOrderTypeForRecommendation = function(resId, orderTypeIds, dish, callBack){
        var rawParams = getCheckSupportedOrderTypeParams(resId, orderTypeIds, dish.recommendation.id);
        
        $rootScope.$broadcast('loading:show');
        ConnectionService.post(api_url.validate_order_type, rawParams).then(function (data) {
            $rootScope.$broadcast('loading:hide');
            if(!data){
                OrderCart.removeRecommendationFromDish(dish.id);
                Utilities.showAlertError(constant.language.err_msg.ordertype_error, error_message.order_type);
                return;
            }
            
            if(callBack){
                callBack();
            }
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
        });
    };
});