skipQueueApp.service('RestaurantService', function (ConnectionService, $state, OrderCart, GlobalRestaurant, $q, Utilities, CrustPizzarBillingSrv,
        $rootScope, $stateParams) {
    // CALL API
    this.getCategoriesByOrderType = function (chainId, restaurantId, orderType, localization) {
        // Prepare raw params
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: restaurantId
            }, {
                prm_name: params_name.language_code,
                prm_value: localization
            }, {
                prm_name: params_name.order_type,
                prm_value: orderType
            }];

        // Create defer
        var dfd = $q.defer();
        
        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.get(api_url.get_category_list, rawParams).then(function (data) {
//        var badUrl = 'http://localhost:8000/api/v3/data/categories'
//        ConnectionService.get(badUrl, rawParams).then(function (data) {
//        ConnectionService.getWithRetry(badUrl, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            console.log('res. service');
//            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.getCategoryAndItsData = function (chainId, resId, orderType, catId, userId, localization) {
        var dfd = $q.defer();
        // Prepare raw params
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: resId
            }, {
                prm_name: params_name.category_id,
                prm_value: catId
            }, {
                prm_name: params_name.language_code,
                prm_value: localization
            }, {
                prm_name: params_name.order_type,
                prm_value: orderType
            }];
        
        var postParams = [ {
                prm_name: params_name.user_id,
                prm_value: userId
            }];
        

        var badUrl = 'http://localhost:8000/api/v3/data/dishes';
        ConnectionService.postWithParams(api_url.get_sub_category_and_item_of_category, rawParams, postParams).then(function (data) {
//        ConnectionService.postWithParams(badUrl, rawParams, postParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });
        return dfd.promise;
    };

    this.getDishInfo = function (dishId, is_recommendation, userId, cusId) {
        
        // Prepare raw params
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: constant.chain_id
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: GlobalRestaurant.getResId()
            }, {
                prm_name: params_name.dish_id,
                prm_value: dishId
            }, {
                prm_name: params_name.language_code,
                prm_value: constant.language_code
            }];

        var postData = [{
                prm_name: params_name.ordertype_ids,
                prm_value: OrderCart.getCart().selectedOrderType
            }, {
                prm_name: params_name.is_recommendations,
                prm_value: is_recommendation ? 1 : 0
            }, {
                prm_name: params_name.user_id,
                prm_value: userId
            }, {
                prm_name: params_name.cus_id,
                prm_value: cusId
            }];

        // Create defer
        var dfd = $q.defer();
        
        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.postWithParams(api_url.get_dish_info, rawParams, postData).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.getRecommendations = function (dishId, userId) {
        console.log("getRecommendations");
        // Prepare raw params
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: constant.chain_id
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: GlobalRestaurant.getResId()
            }, {
                prm_name: params_name.dish_id,
                prm_value: dishId
            }, {
                prm_name: params_name.language_code,
                prm_value: constant.language_code
            }];
        var postParams = [{
                prm_name: params_name.ordertype_ids,
                prm_value: OrderCart.getCart().selectedOrderType
            }, {
                prm_name: params_name.user_id,
                prm_value: userId
            }];

        // Create defer
        var dfd = $q.defer();

        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.postWithParams(api_url.get_recommendations, rawParams, postParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.getTagList = function (chainId, localization) {
        // Prepare raw params
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.language_code,
                prm_value: localization
            }];

        // Create defer
        var dfd = $q.defer();

        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.get(api_url.get_dish_tags, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.getDishByTag = function (chainId, resId, orderTypeIds, tags, keyword, localization, userId) {
        // Prepare raw params
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: resId
            }, {
                prm_name: params_name.ordertype_ids,
                prm_value: orderTypeIds
            }, {
                prm_name: params_name.tags,
                prm_value: tags
            }, {
                prm_name: params_name.keyword,
                prm_value: keyword
            }, {
                prm_name: params_name.language_code,
                prm_value: localization
            }, {
                prm_name: params_name.user_id,
                prm_value: userId
            }];
        

        // Create defer
        var dfd = $q.defer();

        // Call API to get dish by orderType, restaurantId, chainId, localization
        ConnectionService.post(api_url.search_dish_by_tags, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.findRestaurants = function (chainId, lat, long, time, localization) {
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.local_time,
                prm_value: time
            }, {
                prm_name: params_name.language_code,
                prm_value: localization
            }];
        
        if(lat){
            rawParams.push({
                prm_name: params_name.lattitue,
                prm_value: lat
            });
        }
        
        if(long){
            rawParams.push({
                prm_name: params_name.longitue,
                prm_value: long
            });
        }

        // Create defer
        var dfd = $q.defer();

        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.post(api_url.find_restaurants, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
//            $rootScope.$broadcast('loading:hide'); --> caoth: app.js will handle this
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.findRestaurantsOfPickup = function (chainId, orderTypeId, lat, long, time, isLater, localization) {
        var rawParams = [];
        if (isLater) {
            rawParams = [{
                    prm_name: params_name.chain_id,
                    prm_value: chainId
                }, {
                    prm_name: params_name.order_type_id,
                    prm_value: orderTypeId
                }, {
                    prm_name: params_name.local_time,
                    prm_value: time
                }, {
                    prm_name: params_name.language_code,
                    prm_value: localization
                }];
        }
        else {
            rawParams = [{
                    prm_name: params_name.chain_id,
                    prm_value: chainId
                }, {
                    prm_name: params_name.order_type_id,
                    prm_value: orderTypeId
                }, {
                    prm_name: params_name.language_code,
                    prm_value: localization
                }];
        }
        
        if(lat){
            rawParams.push({
                prm_name: params_name.lattitue,
                prm_value: lat
            });
        }
        
        if(long){
            rawParams.push({
                prm_name: params_name.longitue,
                prm_value: long
            });
        }

        // Create defer
        var dfd = $q.defer();

        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.post(api_url.find_restaurants_of_pickup, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
//            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.getRestaurantsOfDelivery = function (chainId, orderTypeId, addressId, datetime, localization) {
        var rawParams = null;

        if (orderTypeId == constant.order_type_child_delivery_now) {
            rawParams = prepareParamsForDeliveryNow(chainId, orderTypeId, addressId, localization);
        }

        if (orderTypeId == constant.order_type_child_delivery_later) {
            rawParams = prepareParamsForDeliveryAdv(chainId, orderTypeId, addressId, localization, datetime);
        }

        if (!rawParams)
            return;

        // Create defer
        var dfd = $q.defer();

        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.post(api_url.find_restaurants_of_delivery, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
//            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.getRestInfo = function (chainId, resId, localization) {
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: resId
            }];

        // Create defer
        var dfd = $q.defer();

        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.get(api_url.get_res_info, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
//            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.getRestInfo = function (chainId, resId, localization) {
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: resId
            }];

        // Create defer
        var dfd = $q.defer();

        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.get(api_url.get_res_info, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.getResPaymentMethod = function (resId) {
        var orderTypeId = OrderCart.getCart().selectedOrderType;
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: constant.chain_id
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: resId
            }, {
                prm_name: params_name.order_type_id,
                prm_value: orderTypeId
            }];

        // Create defer
        var dfd = $q.defer();

        // Call API to get categories by orderType, restaurantId, chainId, localization
        ConnectionService.get(api_url.get_payment_list, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.getFavourites = function (chainId, resId, userId, orderTypeId, localization) {
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: resId
            }, {
                prm_name: params_name.user_id,
                prm_value: userId
            }, {
                prm_name: params_name.order_type_id,
                prm_value: orderTypeId
            }, {
                prm_name: params_name.language_code,
                prm_value: localization
            }];

        // Create defer
        var dfd = $q.defer();

        // Call API to get favorite list by chainId, resId, userId,orderTypeId, localization
        ConnectionService.get(api_url.get_favorite_list, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };

    this.favouriteItem = function (chainId, resId, userId, dishId, isFavourite) {
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: resId
            }, {
                prm_name: params_name.user_id,
                prm_value: userId
            }, {
                prm_name: params_name.dish_id,
                prm_value: dishId
            }, {
                prm_name: params_name.favourite,
                prm_value: isFavourite
            }];

        // Create defer
        var dfd = $q.defer();

        // Call API to favorite by chainId, resId, userId,dishId, isFavourite
        ConnectionService.post(api_url.favorite_user, rawParams).then(function (data) {
            // if success
            // return data to controller
            dfd.resolve(data);
        }, function (error) {
            // if error
            // return error
            dfd.reject(error);
        });

        return dfd.promise;
    };
    // PARSE DATA
    this.parseDataMenu = function (data) {
        var result = [];
        data.forEach(function (category) {
//            var img='';
//            if(category.thumbnail_image)
//                img=''
            var vmCategory = {
                id: category.id,
                name: category.name,
                image: category.thumbnail_image ? category.thumbnail_image : constant.img_category_default
            };
            result.push(vmCategory);
        });

        return result;
    };

    function getDishData(dish, currency) {
        dish.quantity_in_cart = getDishQuantityInCart(dish.id);
        
        var favCounter = getFavCount(dish);
        return {
            id: dish.id,
            name: dish.name,
            image_url: dish.image,
            favCounter: favCounter,
            isLiked: dish.is_liked,
            hasPromotion: dish.promotions ? false : true, //Utilities.emptyOrNull(dish.promote_discount),
            promoDiscount: getPromotionValue(dish),
            orgPrice: currency + dish.org_price.toFixed(constant.number_after_comma),
            price: currency + dish.price.toFixed(constant.number_after_comma),
            showOrgPrice: (dish.org_price !== dish.price),
            quantityInCart: dish.quantity_in_cart,
            isActive: dish.is_active,
            currency: currency
        };
    }

    this.parseDataCategoryPage = function (data) {
        // Get catId and catName from globalRestaurant
        //var catId = GlobalRestaurant.getChoosenCat().id;
        //var catName = GlobalRestaurant.getChoosenCat().name;//'Burger';
        // TODO: move round price to utility
        var subCats = [];
        var currency = data.restaurant.currency_type;
        var dataDishes = [];

        // if dish is in order cart
        // get number of dish then set to view model
        angular.forEach(data.sub_categories, function (subCat) {
            var temp = {
                id: subCat.id,
                name: subCat.name,
                //isShowDishImage: subCat.is_show_dish_image,
                isShowDishImage: subCat.display_mode > 0 ? true : false,
                image_url: subCat.banner_image,
                subSubCategories: [],
                dishes: []
            };

            if (subCat.dishes.length > 0) {
                angular.forEach(subCat.dishes, function (dish) {
                    temp.dishes.push(getDishData(dish, currency));
                });
            }

            if (subCat.sub_sub_categories.length > 0) {
                angular.forEach(subCat.sub_sub_categories, function (subSubCat) {
                    var subSubCatTemp = {
                        id: subSubCat.id,
                        name: subSubCat.name,
                        isShowDishImage: subSubCat.display_mode > 0 ? true : false, //subSubCat.display,
                        image_url: subSubCat.image,
                        dishes: []
                    };

                    if (subSubCat.dishes.length > 0) {
                        angular.forEach(subSubCat.dishes, function (dish) {
                            subSubCatTemp.dishes.push(getDishData(dish, currency));
                        });
                    }

                    temp.subSubCategories.push(subSubCatTemp);
                });
            }

            subCats.push(temp);
        });

        var result = {
            category: {id: data.id, name: data.name, image_url: data.banner_image, isShowImage: data.display_mode > 0 ? true : false},
            subCategories: subCats,
            dishes: dataDishes
        };

        return result;
    };

    this.parseDataDishInfo = function (data) {
        var dishInCart = OrderCart.getDish($stateParams.guid);
        
        var selectedSkuId = dishInCart ? dishInCart.selectedSku.id : 0;
        var currency = data.restaurant.currency_type;
        var subCatId = $state.params.subCatId ? $state.params.subCatId : null;
        
        var dish = {
            id: data.id,
            name: data.name,
            imageUrl: data.image,
            currency: currency,
            favCounter: getFavCount(data),
            hasPromotion: false, //data.promotions ? true : false //Utilities.emptyOrNull(data.promo_discount),
            promoDiscount: getPromotionValue(data), //$.trim(data.promo_discount).replace(' ', '<br/>'),
            description: data.description,
            category: GlobalRestaurant.getChoosenCat(), // get choosen cat from global restaurant
            subCatId: subCatId,
            skus: [],
            quantity: dishInCart ? dishInCart.quantity : 1,
            selectedSku: dishInCart ? dishInCart.selectedSku : null,
            basePrice: 0,
            totalPrice: 0,
            specialIntrustion: dishInCart ? dishInCart.specialIntrustion : '',
            isLiked: data.is_liked,
            isActive: data.is_active,
            customizations: [],
            isRecommendation: data.isRecommendation,
            cusId: data.cusId,
            parentId: data.parentId
        };


        

        // Parse skus
        angular.forEach(data.skus, function (sku) {
            var temp = {
                skuId: sku.id,
                name: sku.name,
                orgPrice: sku.org_price.toFixed(constant.number_after_comma),
                price: sku.price.toFixed(constant.number_after_comma),
                basePrice: sku.base_price.toFixed(constant.number_after_comma),
                customizations: [],
                hasRecommendation: sku.has_recommendations
            };

            // Parse customization and cus_option
            angular.forEach(sku.customizations, function (cus) {

                var cusTemp = {
                    id: cus.id,
                    name: cus.header_text,
                    selected_name: cus.header_text,
                    isShowOptImg: cus.show_image_customization > 0 ? true : false,
                    paidAfter: cus.paid_after,
                    paidAfterValue: cus.paid_price.toFixed(constant.number_after_comma),
                    chooseOptQuantity: 0,
                    minOpt: cus.min_selection,
                    maxOpt: cus.max_selection,
                    options: [],
                    isShowing: false,
                    isHighlight: false
                };

                var cusOfDishInCart = OrderCart.getCusOfDish(dishInCart, cus.id);
                var cusTempOfDishInCart = angular.copy(cusTemp);

                angular.forEach(cus.customization_options, function (opt) {
                    var optTemp = {
                        id: opt.id,
                        name: opt.name,
                        imageUrl: opt.image,
                        orgPrice: opt.org_price.toFixed(constant.number_after_comma),
                        price: opt.price.toFixed(constant.number_after_comma),
                        quantity: 0,
                        hasCounter: opt.has_counter,
                        isPreselected: opt.is_preselected,
                        isPreselectedLocked: opt.is_preselected_locked,
                        isActive: opt.is_active,
                        isStockOut: opt.dish_stock_out
                    };

                    if ((optTemp.isPreselected || optTemp.isPreselectedLocked) && !optTemp.isStockOut) {
                        optTemp.quantity = 1;
                    }

                    var optTempOfDishInCart = angular.copy(optTemp);
                    var optInCusOfDishInCart = OrderCart.getOptionOfCus(cusOfDishInCart, opt.id);
                    if (optInCusOfDishInCart && selectedSkuId === sku.id) {
                        optTempOfDishInCart.quantity = optInCusOfDishInCart.quantity;
                    }
                    
                    if(!optTemp.isActive){
                        optTemp.quantity = 0;
                        optTempOfDishInCart.quantity = 0;
                        optTemp.isPreselectedLocked = 1;
                    }

                    cusTemp.options.push(optTemp);
                    cusTempOfDishInCart.options.push(optTempOfDishInCart);
                });

                temp.customizations.push(cusTemp);
                if (selectedSkuId === sku.id) {
                    dish.customizations.push(cusTempOfDishInCart);
                }
            });

            dish.skus.push(temp);
        });

        return dish;
    };

    this.parseDataDishTags = function (tagList) {
        var result = [];
        angular.forEach(tagList, function (tag) {
            var temp = {
                id: tag.tag_id,
                name: tag.tag_name
            };

            result.push(temp);
        });

        return result;
    };

    this.parseDataGetDishByTag = function (data) {
        var result = [];

        angular.forEach(data, function (dish) {
            var currency = dish.restaurant.currency_type;
            var favCounter = getFavCount(dish);
            dish.quantity_in_cart = getDishQuantityInCart(dish.dish_id);
            var catId = '';
            if(dish.categories && dish.categories.length>0){
                catId = dish.categories[0].id;
            }
            var temp = {
                id: dish.id,
                name: dish.name,
                favCounter: favCounter, //dish.fav_counter,
                isLiked: dish.is_liked, //parseDataGetDishByTag
                hasPromotion: dish.promotions ? false : true, //Utilities.emptyOrNull(dish.promo_discount),
                promoDiscount: getPromotionValue(dish), //$.trim(dish.promo_discount).replace(' ', '<br/>'),
                orderedCounter: getOrderedCount(dish), //dish.ordered_counter,
                fPrice: parseFloat(dish.price), // Price type field is float
                price: currency + dish.price.toFixed(constant.number_after_comma), //dish.price string
                orgPrice: currency + dish.org_price.toFixed(constant.number_after_comma), //dish.org_price,
                currency: currency,
                quantityInCart: dish.quantity_in_cart,
                resId: dish.restaurant.id,
                catId: catId,
                showOrgPrice: (dish.org_price !== dish.price),
                isActive: dish.is_active
            };

            result.push(temp);
        });

        return result;
    };

    this.parseDataRecommendationsPage = function (data) {
        var recommendations = [];

        angular.forEach(data.recommendations, function (recommendation) {
            recommendation.quantity_in_cart = getDishQuantityInCart(recommendation.id);
            var favCounter = getFavCount(recommendation);

            var temp = {
                id: recommendation.dish_id,
                name: recommendation.dish_name,
                image_url: recommendation.dish_image,
                favCounter: favCounter,
                isLiked: recommendation.is_liked,
                hasPromotion: recommendation.promo_discount !== "",
                promoDiscount: recommendation.promo_discount,
                fPrice: parseFloat(recommendation.price),
                price: recommendation.currency + recommendation.price.toFixed(constant.number_after_comma),
                orgPrice: recommendation.currency + recommendation.org_price.toFixed(constant.number_after_comma),
                currency: recommendation.currency,
                quantityInCart: recommendation.quantity_in_cart,
                showOrgPrice: (recommendation.org_price !== recommendation.price),
                isActive: recommendation.is_active,
                isRecommendation: true,
                cusId: recommendation.customization_id,
                parentId: data.parentId
            };

            recommendations.push(temp);
        });

        return recommendations;
    };

    this.parseDataFindRestaurants = function (data) {
        var restaurants = [];
        angular.forEach(data, function (restaurant) {
            var temp = {
                name: restaurant.restaurant_name,
                id: restaurant.restaurant_id,
                distance: restaurant.distance,
                image: restaurant.restaurant_logo_url,
                promotion: restaurant.has_promotion,// == 'true' ? true : false,
                cuisineType: restaurant.cuisine.join(','),
                dinein: false,
                takeout: false,
                delivery: false,
                preorder: false,
                skuHeaderText: restaurant.sku_header_text,
                arr_order_types: restaurant.order_type
            };

            angular.forEach(restaurant.order_type, function (type) {
                if (type == constant.order_type_child_dine_in) {
                    temp.dinein = true;
                }
                if (type == constant.order_type_child_pickup_now || type == constant.order_type_child_pickup_later) {
                    temp.takeout = true;
                }
                if (type == constant.order_type_child_delivery_now || type == constant.order_type_child_delivery_later) {
                    temp.delivery = true;
                }
                if (type == constant.order_type_child_pickup_later || type == constant.order_type_child_delivery_later) {
                    temp.preorder = true;
                }
//                if(type.indexOf(constant.order_type_Pre_Order)>-1){
//                    temp.preorder = true;
//                }
//                temp.dinein = type === constant.order_type_dine_in ? true : temp.dinein;
//                temp.takeout = type === constant.order_type_pickup ? true : temp.takeout;
//                temp.delivery = type === constant.order_type_delivery ? true : temp.delivery;
//                temp.preorder = type === constant.order_type_Pre_Order ? true : temp.preorder;
            });

            restaurants.push(temp);
        });

        return restaurants;
    };

    this.parseDataFindResOfPickup = function (data) {
        var resAval = [];
        var resUnaval = [];
        angular.forEach(data.available_restaurants, function (restaurant) {
            var temp = {
                name: restaurant.restaurant_name,
                id: restaurant.restaurant_id,
                distance: restaurant.distance,
                logo_url: restaurant.restaurant_logo_url,
                lead_time: restaurant.lead_time,
                opening_time: restaurant.opening_time,
                skuHeaderText: restaurant.sku_header_text,
                additional_info: restaurant.additional_info.toString(),
                cuisineType: restaurant.cuisine.join(','),
                lead_time_str: calculateDuration(restaurant.lead_time)
            };
            resAval.push(temp);
        });

        angular.forEach(data.unavailable_restaurants, function (restaurant) {
            var strAdditional_info = '';
            if (restaurant.additional_info.length > 0) {
                strAdditional_info = restaurant.additional_info[0];
            }

            var temp = {
                name: restaurant.restaurant_name,
                id: restaurant.restaurant_id,
                distance: restaurant.distance,
                logo_url: restaurant.restaurant_logo_url,
                lead_time: restaurant.lead_time,
                opening_time: restaurant.opening_time,
                skuHeaderText: restaurant.sku_header_text,
                additional_info: strAdditional_info, // closed time
                cuisineType: restaurant.cuisine.join(','),
                lead_time_str: calculateDuration(restaurant.lead_time)
            };
            resUnaval.push(temp);
        });
        return {availableList: resAval, unavailableList: resUnaval};
    };
    
    var calculateDuration = this.calculateDuration = function(minutes) {
        var days = Math.floor(minutes / 1440);
        var hours = Math.floor((minutes % 1440) / 60);
        var mins = Math.floor((minutes % 1440) % 60);
        var dateTimeDurationString = '';
        if (days > 0) {
            dateTimeDurationString += (days + 'd ');
        }
        if (hours > 0){
            dateTimeDurationString += (hours + 'h ');
        }
        if (mins > 0){
            dateTimeDurationString += (mins + 'm');
        }
        return dateTimeDurationString;
    }

    this.parseDataFindResOfDelivery = function (data) {
        var resAval = [];
        var resUnaval = [];
        angular.forEach(data.available_restaurants, function (restaurant) {
            var temp = {
                name: restaurant.restaurant_name,
                id: restaurant.restaurant_id,
                distance: restaurant.distance,
                logo_url: restaurant.restaurant_logo_url,
                lead_time: restaurant.lead_time,
                opening_time: restaurant.opening_time,
                skuHeaderText: restaurant.sku_header_text,
                additional_info: restaurant.additional_info.toString(),
                cuisineType: restaurant.cuisine.join(','),
                lead_time_str: calculateDuration(restaurant.lead_time)
            };
            resAval.push(temp);
        });

        angular.forEach(data.unavailable_restaurants, function (restaurant) {
            var strAdditional_info = '';
            if (restaurant.additional_info.length > 0) {
                strAdditional_info = restaurant.additional_info[0];
            }

            var temp = {
                name: restaurant.restaurant_name,
                id: restaurant.restaurant_id,
                distance: restaurant.distance,
                logo_url: restaurant.restaurant_logo_url,
                lead_time: restaurant.lead_time,
                opening_time: restaurant.opening_time,
                skuHeaderText: restaurant.sku_header_text,
                additional_info: strAdditional_info, // closed time,
                cuisineType: restaurant.cuisine.join(','),
                lead_time_str: calculateDuration(restaurant.lead_time)
            };
            resUnaval.push(temp);
        });
        return {availableList: resAval, unavailableList: resUnaval};
    };

    this.parseDataResInfo = function (data) {
        var result = {
            id: data.restaurant_id,
            name: data.restaurant_name,
            address: data.address,
            images: data.restaurant_banner,
            phone: data.phone,
            email: data.mail,
            latitude: data.restaurant_latitude,
            longitude: data.restaurant_longitude,
            moreInfo: data.more_info
        };

        return result;
    };

    this.parseDataPaymentMethod = function (data) {
        var result = [];
        angular.forEach(data, function (payment) {
            var temp = {
                name: payment.name,
                imageUrl: payment.image_url,
                type: payment.payment_type,
                baseUrl: payment.base_url
            };
            result.push(temp);
        });
        return result;
    };

    this.parseFavouritesData = function (data) {
        var result = [];

        angular.forEach(data, function (dish) {
            var currency = dish.restaurant.currency_type;
            dish.quantity_in_cart = getDishQuantityInCart(dish.id);
            var fav_counter = getFavCount(dish);
            if (fav_counter > 0) {
                var temp = {
                    id: dish.id,
                    name: dish.name,
                    favCounter: fav_counter, //dish.fav_counter,//
                    isLiked: true, //Utilities.isLikedDish(dish.favorites), //parseDataGetDishByTag
                    hasPromo: dish.promotions ? false : true, //Utilities.emptyOrNull(dish.promo_discount),
                    promoDiscount: getPromotionValue(dish), //$.trim(dish.promo_discount).replace(' ', '<br/>'),
                    orderedCounter: getOrderedCount(dish), //dish.ordered_counter,
                    price: currency + dish.price.toFixed(constant.number_after_comma), //dish.price string
                    orgPrice: currency + dish.org_price.toFixed(constant.number_after_comma), //dish.org_price,
                    currency: currency,
                    showOrgPrice: (dish.org_price !== dish.price),
                    quantityInCart: 0,
                    isActive: true
                };

                result.push(temp);
            }
        });

        return result;
    };


    // LOGIC FUNCTIONS
    this.getSkuHasMinPriceDishDetail = function (dish) {
        var dishInCart = OrderCart.getDish($stateParams.guid);
        
        var selectedSku = null;
        var skus = dish.skus;
        if (dishInCart && dishInCart.selectedSku.id) {
            for (var i = 0; i < skus.length; i++) {
                if (skus[i].skuId === dishInCart.selectedSku.id) {
                    selectedSku = skus[i];
                }
            }
        } else if (skus.length > 0) {
            selectedSku = skus[0];
            for (var i = 1; i < skus.length; i++) {
                if (Utilities.parseToFloat(selectedSku.price) > Utilities.parseToFloat(skus[i].price)) {
                    selectedSku = skus[i];
                }
            }
        }
        return selectedSku;
    };

    this.getCustomizationName = function (dish) {
        return CrustPizzarBillingSrv.getCustomizationName(dish.customizations, dish.currency);
    };

    this.getDishBasePrice = function (chooseDish) {
        return CrustPizzarBillingSrv.getBasePrice(chooseDish);
    };

    this.getDishTotalPrice = function (chooseDish) {
        return CrustPizzarBillingSrv.getTotalPrice(chooseDish);
    };

    var getDishQuantityInCart = this.getDishQuantityInCart = function (dishId) {
        var cart = OrderCart.getCart();
        var dishes = cart.dishes;
        var quantity = 0;
        angular.forEach(Object.keys(dishes), function(guId){
            if(dishes[guId].id == dishId){
                quantity += dishes[guId].quantity;
            }
        });
        return quantity;
    };

    var getPromotionValue = function (dish) {
        var result = '';

        if (dish.promotions) {
            var promo = dish.promotions;
            if (promo.discount_type === 1) {
                result = promo.discount_value + '% <br/> OFF';
            } else if (promo.discount_type === 2) {
                result = '$' + promo.discount_value;
            } else {
                result = 'Free';
            }
        }

        return result;
    };

    var getFavCount = function (dish) {
        if (dish.dish_analytics.length > 0) {
            return dish.dish_analytics[0].total_skipque_fav_count;
        }
        return 0;
    };

    var getOrderedCount = function (dish) {
        if (dish.dish_analytics.length > 0) {
            return dish.dish_analytics[0].total_order_count;
        }

        return 0;
    };

    var prepareSameParamsForFindResByOrderType = function (chainId, orderTypeId, addressId, localization) {
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.order_type_id,
                prm_value: orderTypeId
            }, {
                prm_name: params_name.client_address_id,
                prm_value: addressId
            }, {
                prm_name: params_name.language_code,
                prm_value: localization
            }];

        return rawParams;
    };

    var prepareParamsForDeliveryNow = function (chainId, orderTypeId, addressId, localization) {
        var rawParams = prepareSameParamsForFindResByOrderType(chainId, orderTypeId, addressId, localization);

        return rawParams;
    };

    var prepareParamsForDeliveryAdv = function (chainId, orderTypeId, addressId, localization, datetime) {
        var rawParams = prepareSameParamsForFindResByOrderType(chainId, orderTypeId, addressId, localization);

        rawParams = rawParams.concat([
            {
                prm_name: params_name.local_time,
                prm_value: datetime
            }
        ]);

        return rawParams;
    };
    
    var getCheckRestaurantAvailabilityParams = function(chainId, resId, orderTypeIds, dateTime) {
        var rawParams = [{
                prm_name: params_name.chain_id,
                prm_value: chainId
            }, {
                prm_name: params_name.restaurant_id,
                prm_value: resId
            }, {
                prm_name: params_name.ordertype_ids,
                prm_value: orderTypeIds
            }, {
                prm_name: params_name.local_time,
                prm_value: dateTime
            }];

        return rawParams;
    };
    
    this.checkRestaurantAvailability = function(chainId, resId, orderTypeIds, dateTime, callBack) {
        
        var rawParams = getCheckRestaurantAvailabilityParams(chainId, resId, orderTypeIds, dateTime);
        
        ConnectionService.post(api_url.check_availability, rawParams).then(function (data) {
            if(!data){
                // clear order cart
                OrderCart.clearAll();          
                OrderCart.setSelectedOrderType(orderTypeIds);
                OrderCart.setDateTime(dateTime);
                
                // clear restaurant 
                GlobalRestaurant.clear();
                
                Utilities.showAlertError(constant.language.err_msg.restaurant_not_available, error_message.restaurant_not_available);
                
//                event.preventDefault();
                
//                $rootScope.$broadcast('loading:hide');
//                $state.transitionTo(page_name.res_delivery);
                //$rootScope.$broadcast('loading:hide');
                if(orderTypeIds == constant.order_type_child_delivery_later || orderTypeIds == constant.order_type_child_delivery_now){
//                    $state.transitionTo(page_name.res_delivery);
                    $rootScope.hackPage = page_name.res_delivery;
                }else if (orderTypeIds == constant.order_type_child_pickup_later || orderTypeIds == constant.order_type_child_pickup_now) {
//                    $state.transitionTo(page_name.res_pickup);
                    $rootScope.hackPage = page_name.res_pickup;
                }
            }
            else{
                $rootScope.hackPage = "";
                console.log('check_availability: ' + data);                
            }
            
            if(callBack){
                callBack();
            }
            
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
        });
    };

});