skipQueueApp.service('StaffService', function ($q, ConnectionService, $rootScope) {
    this.parseLoginStaffData = function (data) {
        return {staff_id: data.user_id, username: data.username, name: data.name, email: data.email};
    };
    
    this.getStaffSignIn = function (chainId, email, pass) {
        var dfd = $q.defer();
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.username, prm_value: email},
            {prm_name: params_name.password, prm_value: pass}];

        ConnectionService.post(api_url.staff_sign_in, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };
    
    this.getProfileByPhoneCus = function (chainId, phone) {
        var dfd = $q.defer();
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.phone, prm_value: phone}];

        ConnectionService.post(api_url.search_phone_cus, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };                         

});
