skipQueueApp.service('UserService', function ($q, ConnectionService, CommonService, $rootScope, Utilities, 
                                            $filter, Validation) {
    //Using for SignIn , SignInFB, SignUp
    var _countries = null;
    function _getCountries() {
        var dfd = $q.defer();
        if (!_countries) {
            CommonService.getCountry().then(function (data) {
                // Parse data
                _countries = angular.copy(data);
                dfd.resolve(_countries);
            }, function (error) {
                dfd.reject(error);
            });
        }
        else {
            dfd.resolve(_countries);
        }
        return dfd.promise;
    }
    
    this.parseLoginUserData = function (data) {
        var addressList=[];
        if(data.address){
            angular.forEach(data.address, function (item) {
                if(item){
                    addressList.push({address: item.address,
                                    block_code: item.block_code,
                                    city: item.city,
                                    country: item.country,
                                    state: item.state,
                                    type: item.type,
                                    zip_code: item.zip_code,
                                    id: item.id,
                                    has_change: "0",
                                    is_delete: "0"});
                }
            });
        }

        // caoth: my bad & craziness & stubbornness 
        var dob = data.birthday.indexOf("0000") !== -1 ? null : new Date(data.birthday);
        
        return {
            user_id: data.user_id, avatar: data.avatar, full_name: data.first_name + ' ' + data.last_name, address: addressList, phone: data.phone,
            first_name: data.first_name, last_name: data.last_name, birthday: dob, email: data.email, pass: ''
        };
    };

    this.parseAddressModel = function (addressView) {
        var countryName ='';
        var stateName ='';
        var cityName ='';
        var typeName ='';
        if(addressView.country && addressView.country.id>0){
            countryName = addressView.country.name;
        }
        if(addressView.state && addressView.state.id>0){
            stateName = addressView.state.name;
        }
        if(addressView.city && addressView.city.id>0){
            cityName = addressView.city.name;
        }
        if(addressView.type && addressView.type.id>0){
            typeName = addressView.type.name;
        }
        return {country: countryName,
            state: stateName,
            city: cityName,
            address: addressView.address,
            block_code: addressView.block_code,
            zip_code: addressView.zip_code,
            type: typeName,
            id: addressView.id,
            has_change: addressView.has_change,
            is_delete: addressView.is_delete};
    };

    this.parseAddressData = function(model){
        return _parseAddressData(model);
    };
    
    this.parseItemAddressData = function(itemModel){
        return _parseItemAddress(itemModel);
    };
    
    function _parseAddressData(model) {
        var promises = [];
        if (model && model.length > 0) {
            angular.forEach(model, function (item) {
                var dfd = $q.defer();
                var countries = [];
                var cities = [];
                var states = [];

                var types = constCommonObj.arr_types;

                var country = {name: item.country};
                var state = {name: item.state};
                var city = {name: item.city};
                var type = Utilities.getObjectOfArrByName(types, item.type);

                if (!item.is_delete)
                    item.is_delete = '0';

                if (item.country) {
                    _getCountries().then(function (countriesData) {
                        countries = countriesData;
                        country = Utilities.getObjectOfArrByName(countries, item.country);
                        if (country && country.id > 0) {
                            CommonService.getState(country.id).then(function (objStateData) {
                                states = angular.copy(objStateData);
                                state = Utilities.getObjectOfArrByName(objStateData, item.state);
                                if(!state){
                                    state = {name: constant.language.plh_state, id:-1};
                                }
                                if (state.id > 0) {
                                    CommonService.getCity(state.id).then(function (objData) {
                                        city = Utilities.getObjectOfArrByName(objData, item.city);
                                        cities = angular.copy(objData);
                                        var objAddress = {address: item.address,
                                            block_code: item.block_code,
                                            city: city,
                                            cities: cities,
                                            country: country,
                                            countries: countries,
                                            state: state,
                                            states: states,
                                            type: type,
                                            types: types,
                                            zip_code: item.zip_code,
                                            id: item.id,
                                            has_change: "0",
                                            is_delete: "0"};
                                        dfd.resolve(objAddress);
                                    }, function (error) {
                                        console.log(error);
                                    });
                                }
                                else{
                                    var objAddress = {address: item.address,
                                            block_code: item.block_code,
                                            city: {name: constant.language.plh_city, id:-1},
                                            cities: [],
                                            country: country,
                                            countries: countries,
                                            state: state,
                                            states: states,
                                            type: type,
                                            types: types,
                                            zip_code: item.zip_code,
                                            id: item.id,
                                            has_change: "0",
                                            is_delete: "0"};
                                    dfd.resolve(objAddress);
                                }
                            }, function (error) {
                                console.log(error);
                                 dfd.reject(error);
                            });
                        }
                        else{
                            dfd.reject();
                        }
                    });
                }
                else {
                    var objAddress = {address: item.address,
                        block_code: item.block_code,
                        city: city,
                        cities: cities,
                        country: country,
                        countries: countries,
                        state: state,
                        states: states,
                        type: type,
                        types: types,
                        zip_code: item.zip_code,
                        id: item.id,
                        has_change: "0",
                        is_delete: "0"};
                    dfd.resolve(objAddress);
                }
                promises.push(dfd.promise);
            });
        }
        return $q.all(promises);
    }
    
    function _parseItemAddress(itemModel){
        var dfd = $q.defer();
        var countries = [];
        var cities = [];
        var states = [];

        var types = constCommonObj.arr_types;

        var country = {name: itemModel.country};
        var state = {name: itemModel.state};
        var city = {name: itemModel.city};
        var type = Utilities.getObjectOfArrByName(types, itemModel.type);

        if (!itemModel.is_delete)
            itemModel.is_delete = '0';

        if (itemModel.country) {
            _getCountries().then(function (countriesData) {
                countries = countriesData;
                country = Utilities.getObjectOfArrByName(countries, itemModel.country);
                if (country && country.id > 0) {
                    CommonService.getState(country.id).then(function (objStateData) {
                        states = angular.copy(objStateData);
                        if(itemModel.state !== constant.state_default){
                            state = Utilities.getObjectOfArrByName(objStateData, itemModel.state);
                        }
                        else{
                            state = {name: constant.state_default, id:-1};
                            var objAddress = {address: itemModel.address,
                                    block_code: itemModel.block_code,
                                    city: {name: constant.city_default, id:-1},
                                    cities: [],
                                    country: country,
                                    countries: countries,
                                    state: state,
                                    states: states,
                                    type: type,
                                    types: types,
                                    zip_code: itemModel.zip_code,
                                    id: itemModel.id,
                                    has_change: "0",
                                    is_delete: "0"};
                            dfd.resolve(objAddress);
                        }
                        if (state && state.id > 0) {
                            CommonService.getCity(state.id).then(function (objData) {
                                if(itemModel.state !== constant.state_default){
                                    city = Utilities.getObjectOfArrByName(objData, itemModel.city);
                                }
                                else{
                                    city = {name: constant.city_default, id:-1};
                                }
                                cities = angular.copy(objData);
                                var objAddress = {address: itemModel.address,
                                    block_code: itemModel.block_code,
                                    city: city,
                                    cities: cities,
                                    country: country,
                                    countries: countries,
                                    state: state,
                                    states: states,
                                    type: type,
                                    types: types,
                                    zip_code: itemModel.zip_code,
                                    id: itemModel.id,
                                    has_change: "0",
                                    is_delete: "0"};
                                dfd.resolve(objAddress);
                            }, function (error) {
                                console.log(error);
                            });
                        }
                    }, function (error) {
                        console.log(error);
                         dfd.reject(error);
                    });
                }
            })
        }
        else {
            var objAddress = {address: itemModel.address,
                block_code: itemModel.block_code,
                city: city,
                cities: cities,
                country: country,
                countries: countries,
                state: state,
                states: states,
                type: type,
                types: types,
                zip_code: itemModel.zip_code,
                id: itemModel.id,
                has_change: "0",
                is_delete: "0"};
            dfd.resolve(objAddress);
        }
        return dfd.promise;
    }
    // Using for Profile
    this.parseProfileUserData = function (model) {
        return {user_id: model.user_id,
                        avatar: model.avatar,
                        first_name: model.first_name,
                        last_name: model.last_name,
                        email: model.email,
                        phone: model.phone,
                        birthday: model.birthday,
                        address: model.address,
                        pass: ''
                    };
    };

    this.parseChainHomeData = function (data) {
        var menues = [];

        if (data.menu_sequence.length > 0) {
            var sIcon = '';
            var sCaption = '';
            var sClick = '';
            angular.forEach(data.menu_sequence, function (item) {
                sCaption = item.menu_name;
                sIcon = '';
                sClick = '';
                switch (sCaption) {
//                    case "Promotion Wallet":
//                        sIcon = 'img/menu/icon_promotion_wallet.png';
//                        sClick = "goToPage('')";
//                        break;
                    case "Browse Menu":
                        //sIcon = 'ion-ios-list-outline';
                        sClick = "goToPageWithParams('" + page_name.res_menu + "', {})";
                        break;
                    case "Order Now":
//                        sIcon = 'img/menu/icon_order_now.png';
                        sClick = "goToPage('" + page_name.order_type + "')";
                        break;
                    case "Track Order":
                    {
                        //sIcon = 'img/menu/icon_track_order.png';
                        sClick = 'goToTrackOrderPage()';
                        break;
                    }
                    case "Find Restaurants":
                        //sIcon = 'img/menu/icon-search.png';
//                        sClick = "goToPage('')";//" + page_name.res_find + "
                        sClick = "goToPage('" + page_name.res_find + "')";
                        break;
//                    case "Make Payment":
//                        sIcon = 'img/menu/icon_make_payment.png';
//                        sClick = "goToPage('')";
//                        break;
                    case "Queue Status":
                        //sIcon = 'img/menu/icon_make_payment.png';
                        sClick = "goToPage('')";
                        break;
                    case "Feedback"://Cuong
                        //sIcon = 'img/menu/icon-give-feedback.png';
                        sClick = "goToPage('" + page_name.feedback + "')";
                        break;
                    case "My Profile":
                        //sIcon = 'img/menu/icon_my_profile.png';
                        sClick = "goToPage('" + page_name.profile + "')";
                        break;
                    case "Notification":
                        //sIcon = 'img/menu/icon-notification.png';
                        sClick = "goToPage('" + page_name.notifications + "')";
                        break;
                    case "About":
                        //sIcon = 'img/menu/icon-about.png';
                        sClick = "goToPage('" + page_name.about + "')";
                        break;
                    case "Help":
                        //sIcon = 'img/menu/icon-help.png';
                        sClick = "goToPage('" + page_name.walk_through + "')";
                        break;
//                    case "Share":
//                        sIcon = 'img/menu/icon-share.png';
//                        sClick = "goToPage('')";
//                        break;
                    case "Log Out":
                        //sIcon = 'img/menu/icon_logout.png';
                        sClick = "logOut()";
                        break;
                    default:
                        return;
                        break;
                }
                menues.push({icon: item.image,
                    caption: sCaption,
                    is_hide: item.is_hide,
                    fn_click: sClick});
            });
        }

        return {banner_images: data.banner_images,
            menu_sequence: menues,
            tabsquare_url: data.tabsquare_url};
    };

    this.parseNotificationsData = function (data) {
        var objNotofications = [];
        if (data.notifications && data.notifications.length > 0) {
            angular.forEach(data.notifications, function (item) {
                objNotofications.push({message_id: parseInt(item.message_id.toString()),
                    message: item.message});
            });
        }
        return {"version_key": data.version_key,
            "notifications": objNotofications};
    };
    
    this.parseFAQs = function (data){
        var arrFAQs = [];
        angular.forEach(data, function (item) {
                arrFAQs.push({id:item.id ,question: item.question,answer: item.answer});
            });
        return arrFAQs;
    };

    // call Api 
    this.getSignIn = function (chainId, email, pass, deviceToken) {
        var dfd = $q.defer();
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.username, prm_value: email},
            {prm_name: params_name.password, prm_value: pass},
            {prm_name: params_name.device_token, prm_value: deviceToken}];

        ConnectionService.post(api_url.sign_in, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };

    this.getSignInWithFB = function (chainId, userId, email, socialTypeFB, deviceToken) {
        var dfd = $q.defer();
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.email, prm_value: email},
            {prm_name: params_name.social_account_id, prm_value: userId},
            {prm_name: params_name.social_type, prm_value: socialTypeFB},
            {prm_name: params_name.device_token, prm_value: deviceToken}];

        ConnectionService.post(api_url.sign_in_with_social_account, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };

    this.getUserProfile = function (chainId, userId) {
        var dfd = $q.defer();
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.user_id, prm_value: userId}];
        ConnectionService.get(api_url.get_user_profile, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };

    this.getNotifications = function (chainId, userId, versionKey) {
        var dfd = $q.defer();
        //array paramater
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.user_id, prm_value: userId},
            {prm_name: params_name.version_key, prm_value: versionKey}];
        // Call API "get_notifications"
        ConnectionService.get(api_url.get_notifications, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            //$rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };

    this.signUp = function (chainId, socialAccId, socialType, avatar, pass, first, last, email, dateBirth
            , isReceivePromo, phone, arrAddress, deviceToken) {
        var dfd = $q.defer();
        //array paramater
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.social_account_id, prm_value: socialAccId},
            {prm_name: params_name.social_type, prm_value: socialType},
            {prm_name: params_name.avatar, prm_value: avatar},
            {prm_name: params_name.password, prm_value: pass},
            {prm_name: params_name.first_name, prm_value: first},
            {prm_name: params_name.last_name, prm_value: last},
            {prm_name: params_name.email, prm_value: email},
            {prm_name: params_name.birthday, prm_value: dateBirth},
            {prm_name: params_name.is_receive_promo_and_update, prm_value: isReceivePromo},
            {prm_name: params_name.mobile_no, prm_value: phone},
            {prm_name: params_name.address, prm_value: arrAddress},
            {prm_name: params_name.device_token, prm_value: deviceToken}];
        // Call API "sign_up"
        ConnectionService.post(api_url.sign_up, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };
    
    this.signUpNotRequireEmail = function (chainId, socialAccId, socialType, avatar, pass, first, last, email, dateBirth
            , isReceivePromo, phone, arrAddress, deviceToken, staffId) {
        var dfd = $q.defer();
        //array paramater
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.social_account_id, prm_value: socialAccId},
            {prm_name: params_name.social_type, prm_value: socialType},
            {prm_name: params_name.avatar, prm_value: avatar},
            {prm_name: params_name.password, prm_value: pass},
            {prm_name: params_name.first_name, prm_value: first},
            {prm_name: params_name.last_name, prm_value: last},
            {prm_name: params_name.email, prm_value: email},
            {prm_name: params_name.birthday, prm_value: dateBirth},
            {prm_name: params_name.is_receive_promo_and_update, prm_value: isReceivePromo},
            {prm_name: params_name.mobile_no, prm_value: phone},
            {prm_name: params_name.address, prm_value: arrAddress},
            {prm_name: params_name.device_token, prm_value: deviceToken},
            {prm_name: params_name.staff_id, prm_value: staffId}];
        // Call API "sign_up"        
        ConnectionService.post(api_url.sign_up_not_require_email, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };

    this.updateProfile = function (chainId, profile, staffId) {
        
        if (staffId === undefined) {
            staffId = '';
        }
        
        var dfd = $q.defer();
        //array paramater
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.user_id, prm_value: profile.user_id},
            {prm_name: params_name.avatar, prm_value: profile.avatar},
            {prm_name: params_name.password, prm_value: profile.pass},
            {prm_name: params_name.mobile_no, prm_value: profile.phone},
            {prm_name: params_name.first_name, prm_value: profile.first_name},
            {prm_name: params_name.last_name, prm_value: profile.last_name},
            {prm_name: params_name.email, prm_value: profile.email},
            {prm_name: params_name.birthday, prm_value: profile.birthday},
            {prm_name: params_name.address, prm_value: profile.address},
            {prm_name: params_name.staff_id, prm_value: staffId}
        ];                
        
        // Call API "sign_up"
        var apiUrl = constant.is_skipque ? api_url.update_profile_information : api_url.update_profile_information_by_staff;
        ConnectionService.put(apiUrl, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };

    this.compareAddressEdit = function (arrAddressOld, arrAddressNew) {
//        {'country':'', 'state':'', 'city':'', 'address':'', 'block_code':'','zip_code':'', 
//        'type':'','id':-1,'has_change': 0,'is_delete': 0}
        var addressModel = [];
        angular.forEach(arrAddressNew, function (addr_new) {
            var item = $filter('filter')(arrAddressOld, {id: addr_new.id})[0];
            if (item) {
                if (addr_new.is_delete !== '1' && addr_new.id !== '-1') {
                    var isEdit = false;
                    //compare country, state, city, address, block_code, zip_code, type
                    if (addr_new.country && item.country && addr_new.country.id !== item.country.id) {
                        isEdit = true;
                    }
                    if (addr_new.state && item.state && addr_new.state.id !== item.state.id) {
                        isEdit = true;
                    }
                    if (addr_new.city && item.city && addr_new.city.id !== item.city.id) {
                        isEdit = true;
                    }
                    if (addr_new.address && item.address && addr_new.address !== item.address) {
                        isEdit = true;
                    }
                    if (addr_new.block_code && item.block_code && addr_new.block_code !== item.block_code) {
                        isEdit = true;
                    }
                    if (addr_new.zip_code && item.zip_code && addr_new.zip_code !== item.zip_code) {
                        isEdit = true;
                    }
                    if (addr_new.type && item.type && addr_new.type.id !== item.type.id) {
                        isEdit = true;
                    }
                    //update is_change
                    if (isEdit) {
                        addr_new.has_change = '1';
                    }
                    else {
                        addr_new.has_change = '0';
                    }
                }
            }
            delete addr_new['cities'];
            delete addr_new['states'];
            delete addr_new['countries'];
            delete addr_new['types'];

            var typeName='';
            if(addr_new.type && addr_new.type.id>0)
                typeName = addr_new.type.name;
            var cityName='';
            if(addr_new.city && addr_new.city.id>0)
                cityName = addr_new.city.name;

            addressModel.push({country: addr_new.country.name,
                state: addr_new.state.name,
                city: cityName,
                address: addr_new.address,
                block_code: addr_new.block_code,
                zip_code: addr_new.zip_code,
                type: typeName,
                id: addr_new.id,
                has_change: addr_new.has_change,
                is_delete: addr_new.is_delete});
            
        });
        return addressModel;
    };

    this.validationDateBirth = function (_date) {
        var datetime = moment(_date).format(constant.parse_time_format);
//        if (Validation.isAfterNow(datetime)) { // caoth 472, try not use format: format date (by string constant) from another date ???
        if (Validation.isAfterNow_new(_date)) {
            Utilities.showAlertError(constant.language.mess_title_error, constant.language.msg_date_birth_lesser + Utilities.formatDateTime(constant.formatDate, new Date(_date) ));
            return false;
        }
        return true;
    };
    // About
    this.getFAQs = function (chainId, userId) {
        var dfd = $q.defer();
        //array paramater
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.user_id, prm_value: userId}];
        // Call API "get_faqs"
        ConnectionService.get(api_url.get_faqs, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };
    
    this.sendContactUs = function(chainId, email, message){
        var dfd = $q.defer();
        //array paramater
        var rawParams = [{prm_name: params_name.chain_id, prm_value: chainId},
            {prm_name: params_name.email, prm_value: email},
            {prm_name: params_name.message, prm_value: message}];
        // Call API "sign_up"
        ConnectionService.post(api_url.send_contact_us, rawParams).then(function (data) {
            dfd.resolve(data);
        }, function (error) {
            $rootScope.$broadcast('loading:hide');
            console.log(error);
            dfd.reject(error);
        });
        return dfd.promise;
    };    
});