skipQueueApp.service('Validation', function (Utilities) {

    this.validationEmail = function(email){
        var res = {
            result: true,
            message: ''
        };
        var EMAIL_REGEXP = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        if($.trim(email) !== ''){
            if(!EMAIL_REGEXP.test(email)) {
                res.result = false;
                res.message = constant.language.mess_input_corr_email;
            }
        } 
        else {
            res.result = false;
            res.message = constant.language.mess_not_valid_email;
        }  
        return res;
    };
    
    this.validationEmailNoRequired = function(email){
        var res = {
            result: true,
            message: ''
        };
        var EMAIL_REGEXP = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        if($.trim(email) !== ''){
            if(!EMAIL_REGEXP.test(email)) {
                res.result = false;
                res.message = constant.language.mess_input_corr_email;
            }
        }
        return res;
    };
    
    this.validationPassword = function(pass) {
        var res = {
            result: true,
            message: ''
        };
        if($.trim(pass) !== '') {
            if(constant.is_skipque) {
                if($.trim(pass).length < 8) {
                    res.result = false;
                    res.message = constant.language.mess_pass_at_least_8_char;
                }
            } 
            else {
                if($.trim(pass).length < 4) {
                    res.result = false;
                    res.message = constant.language.mess_pass_at_least_4_char;
                }
            }
        }
        else {
            res.result = false;
            res.message = constant.language.mess_input_pass;
        }
        return res;
    };
    
    this.validationPhone = function(phone){
        var res = {
            result: true,
            message: ''
        };
        var PHONE_REGEXP = constant.phone_format;
        if($.trim(phone) !== ''){
            if(!PHONE_REGEXP.test(phone)) {
                res.result = false;
                res.message = constant.language.mess_input_corr_phone;
            }
        }
        return res;
    };
    
    this.validationZipCode = function(zip_cope){
        var res = {
            result: true,
            message: ''
        };
        var ZIP_CODE_REGEXP = /^\d+$/;
        if($.trim(zip_cope) !== ''){
            if(!ZIP_CODE_REGEXP.test(zip_cope)) {
                res.result = false;
                res.message = constant.language.msg_input_corr_zip_code;
            }
        }
        return res;
    };
    
    this.validationAddress = function(address){
        var arrError = [];
//        if(!address.country || (address.country && (address.country.id < 0 || !address.country.id) ))
        if(!address.country) // caoth: there is st wrong, not sure what wrong
            arrError.push(constant.language.mess_select_Country);
//        if(!address.state || (address.state && (address.state.id < 0 || !address.state.id) ))
//            arrError.push(constant.language.msg_select_state);
        if(!address.address)
            arrError.push(constant.language.mess_input_address);
      
        if(!address.zip_code)
            arrError.push(constant.language.msg_input_zipcode);
         
        if(arrError.length > 0){
            Utilities.showAlertError(constant.language.mess_title_error, arrError.join(' <br /> '));
            return false;
        }
        return true;
    };
    
    this.validationAddressAtIndex = function(address, index){
        var arrError = [];
//        if(!address.country || (address.country && (address.country.id < 0 || !address.country.id) ))
        if(!address.country) // caoth
            arrError.push(constant.language.mess_select_Country);
//        if(!address.state || (address.state && ( address.state.id < 0 || !address.state.id) ))
//            arrError.push(constant.language.msg_select_state);
        if(!address.address)
            arrError.push(constant.language.mess_input_address);
      
        if(!address.zip_code)
            arrError.push(constant.language.msg_input_zipcode);
         
        if(arrError.length > 0){
            Utilities.showAlertError(constant.language.mess_title_error + " - " + constant.language.lbl_address + " " + index.toString(), arrError.join(' <br /> '));
            return false;
        }
        return true;
    };
    // input datetime format yyyy-MM-dd hh:mm:ss. ex: 
    this.isAfterNow = function(datetime){
        var arr = datetime.toString().split(/[- :]/);
        var date = new Date(arr[0], arr[2]-1, arr[1], arr[3], arr[4], arr[5]);
        var temp = moment(date);
        var now = moment();
        return temp.isAfter(now);
        
        // caoth: hic hic tai sao gio nay moi phat hien sai ??? 2016-01-31 vs 2016-02-01 
        // pickup later va make_payment later truyen vo 2 chuoi format khac nhau :|
    };
    
    // input datetime Date() 
    this.isAfterNow_new = function(datetime){
//        var arr = datetime.toString().split(/[- :]/);
//        var date = new Date(arr[0], arr[2]-1, arr[1], arr[3], arr[4], arr[5]);
        var temp = moment(datetime);
        var now = moment();
        return temp.isAfter(now);
        
        // caoth: hic hic tai sao gio nay moi phat hien sai ??? 2016-01-31 vs 2016-02-01 
        // pickup later va make_payment later truyen vo 2 chuoi format khac nhau :|
    };
});